#ifndef BISON_Y_TAB_H
# define BISON_Y_TAB_H

#ifndef PLPGSQL_YYSTYPE
typedef union {
		int32					ival;
		char					*str;
		struct
		{
			char *name;
			int  lineno;
		}						varname;
		struct
		{
			int  nalloc;
			int  nused;
			int	 *nums;
		}						intlist;
		struct
		{
			int  nalloc;
			int  nused;
			PLpgSQL_diag_item *dtitems;
		}						dtlist;
		struct
		{
			int  reverse;
			PLpgSQL_expr *expr;
		}						forilow;
		struct
		{
			char *label;
			int  n_initvars;
			int  *initvarnos;
		}						declhdr;
		PLpgSQL_type			*dtype;
		PLpgSQL_datum			*variable; /* a VAR, RECFIELD, or TRIGARG */
		PLpgSQL_var				*var;
		PLpgSQL_row				*row;
		PLpgSQL_rec				*rec;
		PLpgSQL_expr			*expr;
		PLpgSQL_stmt			*stmt;
		PLpgSQL_stmts			*stmts;
		PLpgSQL_stmt_block		*program;
		PLpgSQL_nsitem			*nsitem;
} plpgsql_yystype;
# define PLPGSQL_YYSTYPE plpgsql_yystype
# define PLPGSQL_YYSTYPE_IS_TRIVIAL 1
#endif
# define	K_ALIAS	257
# define	K_ASSIGN	258
# define	K_BEGIN	259
# define	K_CLOSE	260
# define	K_CONSTANT	261
# define	K_CURSOR	262
# define	K_DEBUG	263
# define	K_DECLARE	264
# define	K_DEFAULT	265
# define	K_DIAGNOSTICS	266
# define	K_DOTDOT	267
# define	K_ELSE	268
# define	K_ELSIF	269
# define	K_END	270
# define	K_EXCEPTION	271
# define	K_EXECUTE	272
# define	K_EXIT	273
# define	K_FOR	274
# define	K_FETCH	275
# define	K_FROM	276
# define	K_GET	277
# define	K_IF	278
# define	K_IN	279
# define	K_INFO	280
# define	K_INTO	281
# define	K_IS	282
# define	K_LOG	283
# define	K_LOOP	284
# define	K_NEXT	285
# define	K_NOT	286
# define	K_NOTICE	287
# define	K_NULL	288
# define	K_OPEN	289
# define	K_PERFORM	290
# define	K_ROW_COUNT	291
# define	K_RAISE	292
# define	K_RECORD	293
# define	K_RENAME	294
# define	K_RESULT_OID	295
# define	K_RETURN	296
# define	K_RETURN_NEXT	297
# define	K_REVERSE	298
# define	K_SELECT	299
# define	K_THEN	300
# define	K_TO	301
# define	K_TYPE	302
# define	K_WARNING	303
# define	K_WHEN	304
# define	K_WHILE	305
# define	T_FUNCTION	306
# define	T_TRIGGER	307
# define	T_STRING	308
# define	T_NUMBER	309
# define	T_VARIABLE	310
# define	T_ROW	311
# define	T_RECORD	312
# define	T_DTYPE	313
# define	T_LABEL	314
# define	T_WORD	315
# define	T_ERROR	316
# define	O_OPTION	317
# define	O_DUMP	318


extern PLPGSQL_YYSTYPE plpgsql_yylval;

#endif /* not BISON_Y_TAB_H */
