/* A Bison parser, made from gram.y
   by GNU bison 1.35.  */

#define PLPGSQL_YYBISON 1  /* Identify Bison output.  */

# define	K_ALIAS	257
# define	K_ASSIGN	258
# define	K_BEGIN	259
# define	K_CLOSE	260
# define	K_CONSTANT	261
# define	K_CURSOR	262
# define	K_DEBUG	263
# define	K_DECLARE	264
# define	K_DEFAULT	265
# define	K_DIAGNOSTICS	266
# define	K_DOTDOT	267
# define	K_ELSE	268
# define	K_ELSIF	269
# define	K_END	270
# define	K_EXCEPTION	271
# define	K_EXECUTE	272
# define	K_EXIT	273
# define	K_FOR	274
# define	K_FETCH	275
# define	K_FROM	276
# define	K_GET	277
# define	K_IF	278
# define	K_IN	279
# define	K_INFO	280
# define	K_INTO	281
# define	K_IS	282
# define	K_LOG	283
# define	K_LOOP	284
# define	K_NEXT	285
# define	K_NOT	286
# define	K_NOTICE	287
# define	K_NULL	288
# define	K_OPEN	289
# define	K_PERFORM	290
# define	K_ROW_COUNT	291
# define	K_RAISE	292
# define	K_RECORD	293
# define	K_RENAME	294
# define	K_RESULT_OID	295
# define	K_RETURN	296
# define	K_RETURN_NEXT	297
# define	K_REVERSE	298
# define	K_SELECT	299
# define	K_THEN	300
# define	K_TO	301
# define	K_TYPE	302
# define	K_WARNING	303
# define	K_WHEN	304
# define	K_WHILE	305
# define	T_FUNCTION	306
# define	T_TRIGGER	307
# define	T_STRING	308
# define	T_NUMBER	309
# define	T_VARIABLE	310
# define	T_ROW	311
# define	T_RECORD	312
# define	T_DTYPE	313
# define	T_LABEL	314
# define	T_WORD	315
# define	T_ERROR	316
# define	O_OPTION	317
# define	O_DUMP	318

#line 1 "gram.y"

/**********************************************************************
 * gram.y				- Parser for the PL/pgSQL
 *						  procedural language
 *
 * IDENTIFICATION
 *	  $Header: /cvsroot/pgsql-server/src/pl/plpgsql/src/gram.y,v 1.37 2002/09/01 16:28:06 tgl Exp $
 *
 *	  This software is copyrighted by Jan Wieck - Hamburg.
 *
 *	  The author hereby grants permission  to  use,  copy,	modify,
 *	  distribute,  and	license this software and its documentation
 *	  for any purpose, provided that existing copyright notices are
 *	  retained	in	all  copies  and  that	this notice is included
 *	  verbatim in any distributions. No written agreement, license,
 *	  or  royalty  fee	is required for any of the authorized uses.
 *	  Modifications to this software may be  copyrighted  by  their
 *	  author  and  need  not  follow  the licensing terms described
 *	  here, provided that the new terms are  clearly  indicated  on
 *	  the first page of each file where they apply.
 *
 *	  IN NO EVENT SHALL THE AUTHOR OR DISTRIBUTORS BE LIABLE TO ANY
 *	  PARTY  FOR  DIRECT,	INDIRECT,	SPECIAL,   INCIDENTAL,	 OR
 *	  CONSEQUENTIAL   DAMAGES  ARISING	OUT  OF  THE  USE  OF  THIS
 *	  SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN
 *	  IF  THE  AUTHOR  HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH
 *	  DAMAGE.
 *
 *	  THE  AUTHOR  AND	DISTRIBUTORS  SPECIFICALLY	 DISCLAIM	ANY
 *	  WARRANTIES,  INCLUDING,  BUT	NOT  LIMITED  TO,  THE	IMPLIED
 *	  WARRANTIES  OF  MERCHANTABILITY,	FITNESS  FOR  A  PARTICULAR
 *	  PURPOSE,	AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON
 *	  AN "AS IS" BASIS, AND THE AUTHOR	AND  DISTRIBUTORS  HAVE  NO
 *	  OBLIGATION   TO	PROVIDE   MAINTENANCE,	 SUPPORT,  UPDATES,
 *	  ENHANCEMENTS, OR MODIFICATIONS.
 *
 **********************************************************************/

#include "plpgsql.h"


static	PLpgSQL_expr	*read_sql_construct(int until,
											const char *expected,
											bool isexpression,
											const char *sqlstart);
static	PLpgSQL_expr	*read_sql_stmt(const char *sqlstart);
static	PLpgSQL_type	*read_datatype(int tok);
static	PLpgSQL_stmt	*make_select_stmt(void);
static	PLpgSQL_stmt	*make_fetch_stmt(void);
static	PLpgSQL_expr	*make_tupret_expr(PLpgSQL_row *row);
static	void check_assignable(PLpgSQL_datum *datum);


#line 55 "gram.y"
#ifndef PLPGSQL_YYSTYPE
typedef union {
		int32					ival;
		char					*str;
		struct
		{
			char *name;
			int  lineno;
		}						varname;
		struct
		{
			int  nalloc;
			int  nused;
			int	 *nums;
		}						intlist;
		struct
		{
			int  nalloc;
			int  nused;
			PLpgSQL_diag_item *dtitems;
		}						dtlist;
		struct
		{
			int  reverse;
			PLpgSQL_expr *expr;
		}						forilow;
		struct
		{
			char *label;
			int  n_initvars;
			int  *initvarnos;
		}						declhdr;
		PLpgSQL_type			*dtype;
		PLpgSQL_datum			*variable; /* a VAR, RECFIELD, or TRIGARG */
		PLpgSQL_var				*var;
		PLpgSQL_row				*row;
		PLpgSQL_rec				*rec;
		PLpgSQL_expr			*expr;
		PLpgSQL_stmt			*stmt;
		PLpgSQL_stmts			*stmts;
		PLpgSQL_stmt_block		*program;
		PLpgSQL_nsitem			*nsitem;
} plpgsql_yystype;
# define PLPGSQL_YYSTYPE plpgsql_yystype
# define PLPGSQL_YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef PLPGSQL_YYDEBUG
# define PLPGSQL_YYDEBUG 0
#endif



#define	PLPGSQL_YYFINAL		232
#define	PLPGSQL_YYFLAG		-32768
#define	PLPGSQL_YYNTBASE	71

/* PLPGSQL_YYTRANSLATE(PLPGSQL_YYLEX) -- Bison token number corresponding to PLPGSQL_YYLEX. */
#define PLPGSQL_YYTRANSLATE(x) ((unsigned)(x) <= 318 ? plpgsql_yytranslate[x] : 144)

/* PLPGSQL_YYTRANSLATE[PLPGSQL_YYLEX] -- Bison token number corresponding to PLPGSQL_YYLEX. */
static const char plpgsql_yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      68,    69,     2,     2,    70,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    65,
      66,     2,    67,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if PLPGSQL_YYDEBUG
static const short plpgsql_yyprhs[] =
{
       0,     0,     5,    10,    11,    13,    16,    18,    21,    22,
      24,    30,    32,    35,    39,    41,    44,    46,    52,    54,
      56,    62,    66,    70,    76,    82,    83,    91,    92,    93,
      97,    99,   103,   106,   108,   110,   112,   114,   116,   118,
     119,   121,   122,   123,   126,   128,   130,   132,   134,   135,
     137,   140,   142,   145,   147,   149,   151,   153,   155,   157,
     159,   161,   163,   165,   167,   169,   171,   173,   175,   177,
     179,   181,   183,   187,   192,   198,   204,   208,   210,   212,
     214,   216,   225,   226,   232,   235,   240,   246,   255,   257,
     259,   261,   262,   271,   280,   282,   284,   287,   292,   295,
     298,   305,   311,   313,   315,   317,   319,   321,   323,   325,
     328,   330,   333,   338,   341,   345,   349,   354,   359,   361,
     363,   365,   367,   368,   369,   370,   371,   377,   378,   380,
     382,   385,   387
};
static const short plpgsql_yyrhs[] =
{
      52,    72,    76,    75,     0,    53,    72,    76,    75,     0,
       0,    73,     0,    73,    74,     0,    74,     0,    63,    64,
       0,     0,    65,     0,    77,     5,   143,    97,    16,     0,
     139,     0,   139,    78,     0,   139,    78,    79,     0,    10,
       0,    79,    80,     0,    80,     0,    66,    66,   142,    67,
      67,     0,    10,     0,    81,     0,    90,    92,    93,    94,
      95,     0,    90,    39,    65,     0,    90,    89,    65,     0,
      90,     3,    20,    88,    65,     0,    40,    91,    47,    91,
      65,     0,     0,    90,     8,    82,    84,    87,    45,    83,
       0,     0,     0,    68,    85,    69,     0,    86,     0,    85,
      70,    86,     0,    90,    93,     0,    28,     0,    20,     0,
      61,     0,    57,     0,    61,     0,    61,     0,     0,     7,
       0,     0,     0,    32,    34,     0,    65,     0,    96,     0,
       4,     0,    11,     0,     0,    98,     0,    98,    99,     0,
      99,     0,    76,    65,     0,   101,     0,   107,     0,   109,
       0,   110,     0,   111,     0,   115,     0,   118,     0,   119,
       0,   120,     0,   121,     0,   122,     0,   128,     0,   129,
       0,   116,     0,   100,     0,   102,     0,   130,     0,   131,
       0,   132,     0,    36,   143,   136,     0,   106,   143,     4,
     136,     0,    23,    12,   143,   103,    65,     0,   103,    70,
     105,     4,   104,     0,   105,     4,   104,     0,    37,     0,
      41,     0,    56,     0,    56,     0,    24,   143,   137,    97,
     108,    16,    24,    65,     0,     0,    15,   143,   137,    97,
     108,     0,    14,    97,     0,   139,    30,   143,   127,     0,
     139,    51,   143,   138,   127,     0,   139,    20,   143,   112,
      25,   114,   138,   127,     0,   113,     0,    56,     0,    61,
       0,     0,   139,    20,   143,   117,    25,    45,   138,   127,
       0,   139,    20,   143,   117,    25,    18,   138,   127,     0,
      58,     0,    57,     0,    45,   143,     0,    19,   143,   140,
     141,     0,    42,   143,     0,    43,   143,     0,    38,   143,
     124,   123,   125,    65,     0,    38,   143,   124,   123,    65,
       0,    54,     0,    17,     0,    49,     0,    33,     0,    26,
       0,    29,     0,     9,     0,   125,   126,     0,   126,     0,
      70,    56,     0,    97,    16,    30,    65,     0,   135,   143,
       0,    18,   143,   136,     0,    35,   143,   133,     0,    21,
     143,   134,    27,     0,     6,   143,   134,    65,     0,    56,
       0,    56,     0,    61,     0,    62,     0,     0,     0,     0,
       0,    66,    66,   142,    67,    67,     0,     0,    60,     0,
      65,     0,    50,   136,     0,    61,     0,     0
};

#endif

#if PLPGSQL_YYDEBUG
/* PLPGSQL_YYRLINE[PLPGSQL_YYN] -- source line where rule number PLPGSQL_YYN was defined. */
static const short plpgsql_yyrline[] =
{
       0,   211,   215,   221,   222,   225,   226,   229,   235,   236,
     239,   260,   268,   276,   287,   293,   295,   299,   301,   303,
     307,   327,   341,   351,   356,   360,   360,   411,   423,   427,
     451,   477,   488,   511,   511,   514,   539,   545,   557,   567,
     569,   573,   584,   586,   590,   592,   643,   644,   647,   655,
     659,   670,   687,   689,   691,   693,   695,   697,   699,   701,
     703,   705,   707,   709,   711,   713,   715,   717,   719,   721,
     723,   725,   729,   745,   761,   778,   793,   803,   807,   813,
     821,   828,   845,   853,   896,   902,   920,   939,   961,   987,
     997,  1009,  1028,  1058,  1088,  1090,  1096,  1103,  1119,  1162,
    1193,  1209,  1226,  1232,  1236,  1240,  1244,  1248,  1252,  1258,
    1271,  1280,  1286,  1290,  1303,  1316,  1430,  1442,  1455,  1470,
    1485,  1487,  1491,  1495,  1499,  1503,  1508,  1515,  1517,  1521,
    1523,  1527,  1537
};
#endif


#if (PLPGSQL_YYDEBUG) || defined PLPGSQL_YYERROR_VERBOSE

/* PLPGSQL_YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const plpgsql_yytname[] =
{
  "$", "error", "$undefined.", "K_ALIAS", "K_ASSIGN", "K_BEGIN", "K_CLOSE", 
  "K_CONSTANT", "K_CURSOR", "K_DEBUG", "K_DECLARE", "K_DEFAULT", 
  "K_DIAGNOSTICS", "K_DOTDOT", "K_ELSE", "K_ELSIF", "K_END", 
  "K_EXCEPTION", "K_EXECUTE", "K_EXIT", "K_FOR", "K_FETCH", "K_FROM", 
  "K_GET", "K_IF", "K_IN", "K_INFO", "K_INTO", "K_IS", "K_LOG", "K_LOOP", 
  "K_NEXT", "K_NOT", "K_NOTICE", "K_NULL", "K_OPEN", "K_PERFORM", 
  "K_ROW_COUNT", "K_RAISE", "K_RECORD", "K_RENAME", "K_RESULT_OID", 
  "K_RETURN", "K_RETURN_NEXT", "K_REVERSE", "K_SELECT", "K_THEN", "K_TO", 
  "K_TYPE", "K_WARNING", "K_WHEN", "K_WHILE", "T_FUNCTION", "T_TRIGGER", 
  "T_STRING", "T_NUMBER", "T_VARIABLE", "T_ROW", "T_RECORD", "T_DTYPE", 
  "T_LABEL", "T_WORD", "T_ERROR", "O_OPTION", "O_DUMP", "';'", "'<'", 
  "'>'", "'('", "')'", "','", "pl_function", "comp_optsect", 
  "comp_options", "comp_option", "opt_semi", "pl_block", "decl_sect", 
  "decl_start", "decl_stmts", "decl_stmt", "decl_statement", "@1", 
  "decl_cursor_query", "decl_cursor_args", "decl_cursor_arglist", 
  "decl_cursor_arg", "decl_is_from", "decl_aliasitem", "decl_rowtype", 
  "decl_varname", "decl_renname", "decl_const", "decl_datatype", 
  "decl_notnull", "decl_defval", "decl_defkey", "proc_sect", "proc_stmts", 
  "proc_stmt", "stmt_perform", "stmt_assign", "stmt_getdiag", 
  "getdiag_list", "getdiag_item", "getdiag_target", "assign_var", 
  "stmt_if", "stmt_else", "stmt_loop", "stmt_while", "stmt_fori", 
  "fori_var", "fori_varname", "fori_lower", "stmt_fors", "stmt_dynfors", 
  "fors_target", "stmt_select", "stmt_exit", "stmt_return", 
  "stmt_return_next", "stmt_raise", "raise_msg", "raise_level", 
  "raise_params", "raise_param", "loop_body", "stmt_execsql", 
  "stmt_dynexecute", "stmt_open", "stmt_fetch", "stmt_close", 
  "cursor_varptr", "cursor_variable", "execsql_start", "expr_until_semi", 
  "expr_until_then", "expr_until_loop", "opt_label", "opt_exitlabel", 
  "opt_exitcond", "opt_lblname", "lno", 0
};
#endif

/* PLPGSQL_YYR1[PLPGSQL_YYN] -- Symbol number of symbol that rule PLPGSQL_YYN derives. */
static const short plpgsql_yyr1[] =
{
       0,    71,    71,    72,    72,    73,    73,    74,    75,    75,
      76,    77,    77,    77,    78,    79,    79,    80,    80,    80,
      81,    81,    81,    81,    81,    82,    81,    83,    84,    84,
      85,    85,    86,    87,    87,    88,    89,    90,    91,    92,
      92,    93,    94,    94,    95,    95,    96,    96,    97,    97,
      98,    98,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,   100,   101,   102,   103,   103,   104,   104,   105,
     106,   107,   108,   108,   108,   109,   110,   111,   112,   113,
     113,   114,   115,   116,   117,   117,   118,   119,   120,   121,
     122,   122,   123,   124,   124,   124,   124,   124,   124,   125,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   135,   136,   137,   138,   139,   139,   140,   140,   141,
     141,   142,   143
};

/* PLPGSQL_YYR2[PLPGSQL_YYN] -- Number of symbols composing right hand side of rule PLPGSQL_YYN. */
static const short plpgsql_yyr2[] =
{
       0,     4,     4,     0,     1,     2,     1,     2,     0,     1,
       5,     1,     2,     3,     1,     2,     1,     5,     1,     1,
       5,     3,     3,     5,     5,     0,     7,     0,     0,     3,
       1,     3,     2,     1,     1,     1,     1,     1,     1,     0,
       1,     0,     0,     2,     1,     1,     1,     1,     0,     1,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     4,     5,     5,     3,     1,     1,     1,
       1,     8,     0,     5,     2,     4,     5,     8,     1,     1,
       1,     0,     8,     8,     1,     1,     2,     4,     2,     2,
       6,     5,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     4,     2,     3,     3,     4,     4,     1,     1,
       1,     1,     0,     0,     0,     0,     5,     0,     1,     1,
       2,     1,     0
};

/* PLPGSQL_YYDEFACT[S] -- default rule to reduce with in state S when PLPGSQL_YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short plpgsql_yydefact[] =
{
       0,     3,     3,     0,   125,     4,     6,   125,     7,     0,
       8,     0,    11,     5,     8,     0,     9,     1,   132,    14,
      12,     2,   131,     0,   125,    18,     0,    37,     0,    13,
      16,    19,    39,     0,   132,   132,   132,   132,     0,   132,
     132,   132,   132,   132,   132,   132,    80,   120,   121,     0,
       0,   125,    51,    67,    53,    68,   132,    54,    55,    56,
      57,    58,    66,    59,    60,    61,    62,    63,    64,    65,
      69,    70,    71,   132,    11,    38,     0,     0,    15,     0,
      40,    25,     0,    36,     0,    41,   126,     0,   122,   127,
       0,   132,   123,     0,   122,     0,    98,    99,    96,    52,
      10,    50,     0,   113,   132,   132,   132,     0,     0,     0,
      28,    21,    22,    42,   119,     0,   114,   128,     0,     0,
       0,   125,   118,   115,    72,   108,   103,   106,   107,   105,
     104,     0,   122,     0,   125,   124,     0,     0,    35,     0,
       0,     0,     0,     0,   117,   122,   129,    97,   116,    79,
       0,     0,    82,   102,     0,    73,    89,    95,    94,    90,
       0,    88,     0,     0,    85,   125,    24,    17,    23,     0,
      30,    41,    34,    33,     0,    43,    46,    47,    44,    20,
      45,   130,    74,     0,     0,   125,   132,     0,   101,     0,
       0,   110,    91,     0,     0,    86,    29,     0,    32,    27,
       0,    77,    78,    76,    84,   123,     0,   111,   100,   109,
     124,   124,   124,     0,    31,    26,     0,   125,     0,   125,
     125,   125,   112,    75,    82,    81,    87,    93,    92,    83,
       0,     0,     0
};

static const short plpgsql_yydefgoto[] =
{
     230,     4,     5,     6,    17,    49,    11,    20,    29,    30,
      31,   110,   215,   141,   169,   170,   174,   139,    84,    32,
      76,    85,   113,   143,   179,   180,   163,    51,    52,    53,
      54,    55,   150,   203,   151,    56,    57,   187,    58,    59,
      60,   160,   161,   210,    61,    62,   162,    63,    64,    65,
      66,    67,   154,   131,   190,   191,   164,    68,    69,    70,
      71,    72,   123,   115,    73,   116,   121,   165,    74,   118,
     147,    23,    24
};

static const short plpgsql_yypact[] =
{
       3,   -44,   -44,   -25,   -16,   -44,-32768,   -16,-32768,    16,
      19,    81,    88,-32768,    19,    30,-32768,-32768,-32768,-32768,
       4,-32768,-32768,    22,   128,-32768,    38,-32768,    36,     4,
  -32768,-32768,    28,    37,-32768,-32768,-32768,-32768,    91,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    40,
      98,    45,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    27,-32768,    69,    30,-32768,    99,
  -32768,-32768,    55,-32768,    56,-32768,-32768,    66,-32768,    63,
      66,-32768,-32768,    68,-32768,   148,-32768,-32768,-32768,-32768,
  -32768,-32768,   121,-32768,-32768,-32768,-32768,    38,    59,    67,
      65,-32768,-32768,    95,-32768,    70,-32768,-32768,   -32,   104,
      82,    94,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    86,-32768,   -31,   128,-32768,    76,    75,-32768,    78,
      84,    -4,   114,     9,-32768,-32768,-32768,-32768,-32768,-32768,
     -48,   150,    79,-32768,   -36,-32768,-32768,-32768,-32768,-32768,
     133,-32768,   134,   146,-32768,   128,-32768,-32768,-32768,    26,
  -32768,-32768,-32768,-32768,   122,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,    82,    -9,   128,-32768,   152,-32768,   113,
     -27,-32768,-32768,    -3,   142,-32768,-32768,    84,-32768,-32768,
     171,-32768,-32768,-32768,-32768,-32768,   154,-32768,-32768,-32768,
  -32768,-32768,-32768,   111,-32768,-32768,    -9,    94,   115,   128,
     128,   128,-32768,-32768,    79,-32768,-32768,-32768,-32768,-32768,
     179,   182,-32768
};

static const short plpgsql_yypgoto[] =
{
  -32768,   181,-32768,   180,   172,    41,-32768,-32768,-32768,   158,
  -32768,-32768,-32768,-32768,-32768,    -6,-32768,-32768,-32768,  -135,
      85,-32768,    17,-32768,-32768,-32768,   -24,-32768,   144,-32768,
  -32768,-32768,-32768,   -20,    15,-32768,-32768,   -23,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    10,  -144,-32768,-32768,-32768,
  -32768,-32768,-32768,   109,-32768,   -53,    -2,  -158,    42,-32768,
  -32768,   125,   -33
};


#define	PLPGSQL_YYLAST		203


static const short plpgsql_yytable[] =
{
      50,    87,    88,    89,    90,   171,    92,    93,    94,    95,
      96,    97,    98,   176,    25,   211,   172,   182,   145,     3,
     177,   195,   183,   102,   173,   156,   157,   158,   201,   188,
     159,    79,   202,   146,   189,    80,    81,    19,   208,     8,
     103,   124,   212,   189,    26,    10,    12,   104,    14,    12,
       9,    34,   219,   220,   221,     1,     2,   105,   120,   -49,
     -49,   -49,   171,    35,    36,    27,    37,    82,    38,    39,
      28,   133,   134,   135,   178,   226,   227,   228,   106,   155,
      40,    41,    15,    42,    16,    83,    18,    43,    44,    33,
      45,    22,   181,   185,   186,   196,   197,   152,    19,    75,
      34,    46,    77,    91,    86,    99,    47,    48,   -48,   -48,
     -48,     9,    35,    36,   100,    37,   107,    38,    39,   109,
     111,   112,   114,   117,   122,   132,   137,   142,   138,    40,
      41,   148,    42,   140,    34,   144,    43,    44,   149,    45,
     153,   166,   167,   168,   -48,    27,    35,    36,   175,    37,
      46,    38,    39,   205,   184,    47,    48,   125,   192,   193,
       9,   204,   194,    40,    41,   126,    42,   199,   206,   207,
      43,    44,   213,    45,   127,   216,   222,   128,   218,   231,
     225,   129,   232,     7,    46,    13,    21,    78,   198,    47,
      48,   214,   136,   224,     9,   101,   223,   130,   200,   119,
     209,   229,   108,   217
};

static const short plpgsql_yycheck[] =
{
      24,    34,    35,    36,    37,   140,    39,    40,    41,    42,
      43,    44,    45,     4,    10,    18,    20,    65,    50,    63,
      11,   165,    70,    56,    28,    56,    57,    58,    37,    65,
      61,     3,    41,    65,    70,     7,     8,    10,    65,    64,
      73,    94,    45,    70,    40,     4,     4,    20,     7,     7,
      66,     6,   210,   211,   212,    52,    53,    30,    91,    14,
      15,    16,   197,    18,    19,    61,    21,    39,    23,    24,
      66,   104,   105,   106,    65,   219,   220,   221,    51,   132,
      35,    36,    66,    38,    65,    57,     5,    42,    43,    67,
      45,    61,   145,    14,    15,    69,    70,   121,    10,    61,
       6,    56,    66,    12,    67,    65,    61,    62,    14,    15,
      16,    66,    18,    19,    16,    21,    47,    23,    24,    20,
      65,    65,    56,    60,    56,     4,    67,    32,    61,    35,
      36,    27,    38,    68,     6,    65,    42,    43,    56,    45,
      54,    65,    67,    65,    16,    61,    18,    19,    34,    21,
      56,    23,    24,   186,     4,    61,    62,     9,    25,    25,
      66,   185,    16,    35,    36,    17,    38,    45,    16,    56,
      42,    43,    30,    45,    26,     4,    65,    29,    24,     0,
      65,    33,     0,     2,    56,     5,    14,    29,   171,    61,
      62,   197,   107,   217,    66,    51,   216,    49,   183,    90,
     190,   224,    77,   205
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with plpgsql_yy or PLPGSQL_YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (plpgsql_yyoverflow) || defined (PLPGSQL_YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if PLPGSQL_YYSTACK_USE_ALLOCA
#  define PLPGSQL_YYSTACK_ALLOC alloca
# else
#  ifndef PLPGSQL_YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define PLPGSQL_YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define PLPGSQL_YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef PLPGSQL_YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define PLPGSQL_YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define PLPGSQL_YYSIZE_T size_t
#  endif
#  define PLPGSQL_YYSTACK_ALLOC malloc
#  define PLPGSQL_YYSTACK_FREE free
# endif
#endif /* ! defined (plpgsql_yyoverflow) || defined (PLPGSQL_YYERROR_VERBOSE) */


#if (! defined (plpgsql_yyoverflow) \
     && (! defined (__cplusplus) \
	 || (PLPGSQL_YYLTYPE_IS_TRIVIAL && PLPGSQL_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union plpgsql_yyalloc
{
  short plpgsql_yyss;
  PLPGSQL_YYSTYPE plpgsql_yyvs;
# if PLPGSQL_YYLSP_NEEDED
  PLPGSQL_YYLTYPE plpgsql_yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define PLPGSQL_YYSTACK_GAP_MAX (sizeof (union plpgsql_yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if PLPGSQL_YYLSP_NEEDED
#  define PLPGSQL_YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (PLPGSQL_YYSTYPE) + sizeof (PLPGSQL_YYLTYPE))	\
      + 2 * PLPGSQL_YYSTACK_GAP_MAX)
# else
#  define PLPGSQL_YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (PLPGSQL_YYSTYPE))				\
      + PLPGSQL_YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef PLPGSQL_YYCOPY
#  if 1 < __GNUC__
#   define PLPGSQL_YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define PLPGSQL_YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register PLPGSQL_YYSIZE_T plpgsql_yyi;		\
	  for (plpgsql_yyi = 0; plpgsql_yyi < (Count); plpgsql_yyi++)	\
	    (To)[plpgsql_yyi] = (From)[plpgsql_yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables PLPGSQL_YYSIZE and PLPGSQL_YYSTACKSIZE give the old and new number of
   elements in the stack, and PLPGSQL_YYPTR gives the new location of the
   stack.  Advance PLPGSQL_YYPTR to a properly aligned location for the next
   stack.  */
# define PLPGSQL_YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	PLPGSQL_YYSIZE_T plpgsql_yynewbytes;						\
	PLPGSQL_YYCOPY (&plpgsql_yyptr->Stack, Stack, plpgsql_yysize);				\
	Stack = &plpgsql_yyptr->Stack;						\
	plpgsql_yynewbytes = plpgsql_yystacksize * sizeof (*Stack) + PLPGSQL_YYSTACK_GAP_MAX;	\
	plpgsql_yyptr += plpgsql_yynewbytes / sizeof (*plpgsql_yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (PLPGSQL_YYSIZE_T) && defined (__SIZE_TYPE__)
# define PLPGSQL_YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (PLPGSQL_YYSIZE_T) && defined (size_t)
# define PLPGSQL_YYSIZE_T size_t
#endif
#if ! defined (PLPGSQL_YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define PLPGSQL_YYSIZE_T size_t
# endif
#endif
#if ! defined (PLPGSQL_YYSIZE_T)
# define PLPGSQL_YYSIZE_T unsigned int
#endif

#define plpgsql_yyerrok		(plpgsql_yyerrstatus = 0)
#define plpgsql_yyclearin	(plpgsql_yychar = PLPGSQL_YYEMPTY)
#define PLPGSQL_YYEMPTY		-2
#define PLPGSQL_YYEOF		0
#define PLPGSQL_YYACCEPT	goto plpgsql_yyacceptlab
#define PLPGSQL_YYABORT 	goto plpgsql_yyabortlab
#define PLPGSQL_YYERROR		goto plpgsql_yyerrlab1
/* Like PLPGSQL_YYERROR except do call plpgsql_yyerror.  This remains here temporarily
   to ease the transition to the new meaning of PLPGSQL_YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define PLPGSQL_YYFAIL		goto plpgsql_yyerrlab
#define PLPGSQL_YYRECOVERING()  (!!plpgsql_yyerrstatus)
#define PLPGSQL_YYBACKUP(Token, Value)					\
do								\
  if (plpgsql_yychar == PLPGSQL_YYEMPTY && plpgsql_yylen == 1)				\
    {								\
      plpgsql_yychar = (Token);						\
      plpgsql_yylval = (Value);						\
      plpgsql_yychar1 = PLPGSQL_YYTRANSLATE (plpgsql_yychar);				\
      PLPGSQL_YYPOPSTACK;						\
      goto plpgsql_yybackup;						\
    }								\
  else								\
    { 								\
      plpgsql_yyerror ("syntax error: cannot back up");			\
      PLPGSQL_YYERROR;							\
    }								\
while (0)

#define PLPGSQL_YYTERROR	1
#define PLPGSQL_YYERRCODE	256


/* PLPGSQL_YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When PLPGSQL_YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef PLPGSQL_YYLLOC_DEFAULT
# define PLPGSQL_YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* PLPGSQL_YYLEX -- calling `plpgsql_yylex' with the right arguments.  */

#if PLPGSQL_YYPURE
# if PLPGSQL_YYLSP_NEEDED
#  ifdef PLPGSQL_YYLEX_PARAM
#   define PLPGSQL_YYLEX		plpgsql_yylex (&plpgsql_yylval, &plpgsql_yylloc, PLPGSQL_YYLEX_PARAM)
#  else
#   define PLPGSQL_YYLEX		plpgsql_yylex (&plpgsql_yylval, &plpgsql_yylloc)
#  endif
# else /* !PLPGSQL_YYLSP_NEEDED */
#  ifdef PLPGSQL_YYLEX_PARAM
#   define PLPGSQL_YYLEX		plpgsql_yylex (&plpgsql_yylval, PLPGSQL_YYLEX_PARAM)
#  else
#   define PLPGSQL_YYLEX		plpgsql_yylex (&plpgsql_yylval)
#  endif
# endif /* !PLPGSQL_YYLSP_NEEDED */
#else /* !PLPGSQL_YYPURE */
# define PLPGSQL_YYLEX			plpgsql_yylex ()
#endif /* !PLPGSQL_YYPURE */


/* Enable debugging if requested.  */
#if PLPGSQL_YYDEBUG

# ifndef PLPGSQL_YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define PLPGSQL_YYFPRINTF fprintf
# endif

# define PLPGSQL_YYDPRINTF(Args)			\
do {						\
  if (plpgsql_yydebug)					\
    PLPGSQL_YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int plpgsql_yydebug;
#else /* !PLPGSQL_YYDEBUG */
# define PLPGSQL_YYDPRINTF(Args)
#endif /* !PLPGSQL_YYDEBUG */

/* PLPGSQL_YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	PLPGSQL_YYINITDEPTH
# define PLPGSQL_YYINITDEPTH 200
#endif

/* PLPGSQL_YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < PLPGSQL_YYSTACK_BYTES (PLPGSQL_YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if PLPGSQL_YYMAXDEPTH == 0
# undef PLPGSQL_YYMAXDEPTH
#endif

#ifndef PLPGSQL_YYMAXDEPTH
# define PLPGSQL_YYMAXDEPTH 10000
#endif

#ifdef PLPGSQL_YYERROR_VERBOSE

# ifndef plpgsql_yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define plpgsql_yystrlen strlen
#  else
/* Return the length of PLPGSQL_YYSTR.  */
static PLPGSQL_YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
plpgsql_yystrlen (const char *plpgsql_yystr)
#   else
plpgsql_yystrlen (plpgsql_yystr)
     const char *plpgsql_yystr;
#   endif
{
  register const char *plpgsql_yys = plpgsql_yystr;

  while (*plpgsql_yys++ != '\0')
    continue;

  return plpgsql_yys - plpgsql_yystr - 1;
}
#  endif
# endif

# ifndef plpgsql_yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define plpgsql_yystpcpy stpcpy
#  else
/* Copy PLPGSQL_YYSRC to PLPGSQL_YYDEST, returning the address of the terminating '\0' in
   PLPGSQL_YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
plpgsql_yystpcpy (char *plpgsql_yydest, const char *plpgsql_yysrc)
#   else
plpgsql_yystpcpy (plpgsql_yydest, plpgsql_yysrc)
     char *plpgsql_yydest;
     const char *plpgsql_yysrc;
#   endif
{
  register char *plpgsql_yyd = plpgsql_yydest;
  register const char *plpgsql_yys = plpgsql_yysrc;

  while ((*plpgsql_yyd++ = *plpgsql_yys++) != '\0')
    continue;

  return plpgsql_yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/local/share/bison/bison.simple"


/* The user can define PLPGSQL_YYPARSE_PARAM as the name of an argument to be passed
   into plpgsql_yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef PLPGSQL_YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define PLPGSQL_YYPARSE_PARAM_ARG void *PLPGSQL_YYPARSE_PARAM
#  define PLPGSQL_YYPARSE_PARAM_DECL
# else
#  define PLPGSQL_YYPARSE_PARAM_ARG PLPGSQL_YYPARSE_PARAM
#  define PLPGSQL_YYPARSE_PARAM_DECL void *PLPGSQL_YYPARSE_PARAM;
# endif
#else /* !PLPGSQL_YYPARSE_PARAM */
# define PLPGSQL_YYPARSE_PARAM_ARG
# define PLPGSQL_YYPARSE_PARAM_DECL
#endif /* !PLPGSQL_YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef PLPGSQL_YYPARSE_PARAM
int plpgsql_yyparse (void *);
# else
int plpgsql_yyparse (void);
# endif
#endif

/* PLPGSQL_YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to PLPGSQL_YYPARSE.  */

#define PLPGSQL_YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int plpgsql_yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
PLPGSQL_YYSTYPE plpgsql_yylval;						\
							\
/* Number of parse errors so far.  */			\
int plpgsql_yynerrs;

#if PLPGSQL_YYLSP_NEEDED
# define PLPGSQL_YY_DECL_VARIABLES			\
PLPGSQL_YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
PLPGSQL_YYLTYPE plpgsql_yylloc;
#else
# define PLPGSQL_YY_DECL_VARIABLES			\
PLPGSQL_YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !PLPGSQL_YYPURE
PLPGSQL_YY_DECL_VARIABLES
#endif  /* !PLPGSQL_YYPURE */

int
plpgsql_yyparse (PLPGSQL_YYPARSE_PARAM_ARG)
     PLPGSQL_YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if PLPGSQL_YYPURE
  PLPGSQL_YY_DECL_VARIABLES
#endif  /* !PLPGSQL_YYPURE */

  register int plpgsql_yystate;
  register int plpgsql_yyn;
  int plpgsql_yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int plpgsql_yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int plpgsql_yychar1 = 0;

  /* Three stacks and their tools:
     `plpgsql_yyss': related to states,
     `plpgsql_yyvs': related to semantic values,
     `plpgsql_yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow plpgsql_yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	plpgsql_yyssa[PLPGSQL_YYINITDEPTH];
  short *plpgsql_yyss = plpgsql_yyssa;
  register short *plpgsql_yyssp;

  /* The semantic value stack.  */
  PLPGSQL_YYSTYPE plpgsql_yyvsa[PLPGSQL_YYINITDEPTH];
  PLPGSQL_YYSTYPE *plpgsql_yyvs = plpgsql_yyvsa;
  register PLPGSQL_YYSTYPE *plpgsql_yyvsp;

#if PLPGSQL_YYLSP_NEEDED
  /* The location stack.  */
  PLPGSQL_YYLTYPE plpgsql_yylsa[PLPGSQL_YYINITDEPTH];
  PLPGSQL_YYLTYPE *plpgsql_yyls = plpgsql_yylsa;
  PLPGSQL_YYLTYPE *plpgsql_yylsp;
#endif

#if PLPGSQL_YYLSP_NEEDED
# define PLPGSQL_YYPOPSTACK   (plpgsql_yyvsp--, plpgsql_yyssp--, plpgsql_yylsp--)
#else
# define PLPGSQL_YYPOPSTACK   (plpgsql_yyvsp--, plpgsql_yyssp--)
#endif

  PLPGSQL_YYSIZE_T plpgsql_yystacksize = PLPGSQL_YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  PLPGSQL_YYSTYPE plpgsql_yyval;
#if PLPGSQL_YYLSP_NEEDED
  PLPGSQL_YYLTYPE plpgsql_yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int plpgsql_yylen;

  PLPGSQL_YYDPRINTF ((stderr, "Starting parse\n"));

  plpgsql_yystate = 0;
  plpgsql_yyerrstatus = 0;
  plpgsql_yynerrs = 0;
  plpgsql_yychar = PLPGSQL_YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  plpgsql_yyssp = plpgsql_yyss;
  plpgsql_yyvsp = plpgsql_yyvs;
#if PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp = plpgsql_yyls;
#endif
  goto plpgsql_yysetstate;

/*------------------------------------------------------------.
| plpgsql_yynewstate -- Push a new state, which is found in plpgsql_yystate.  |
`------------------------------------------------------------*/
 plpgsql_yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  plpgsql_yyssp++;

 plpgsql_yysetstate:
  *plpgsql_yyssp = plpgsql_yystate;

  if (plpgsql_yyssp >= plpgsql_yyss + plpgsql_yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      PLPGSQL_YYSIZE_T plpgsql_yysize = plpgsql_yyssp - plpgsql_yyss + 1;

#ifdef plpgsql_yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	PLPGSQL_YYSTYPE *plpgsql_yyvs1 = plpgsql_yyvs;
	short *plpgsql_yyss1 = plpgsql_yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if PLPGSQL_YYLSP_NEEDED
	PLPGSQL_YYLTYPE *plpgsql_yyls1 = plpgsql_yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if plpgsql_yyoverflow is a macro.  */
	plpgsql_yyoverflow ("parser stack overflow",
		    &plpgsql_yyss1, plpgsql_yysize * sizeof (*plpgsql_yyssp),
		    &plpgsql_yyvs1, plpgsql_yysize * sizeof (*plpgsql_yyvsp),
		    &plpgsql_yyls1, plpgsql_yysize * sizeof (*plpgsql_yylsp),
		    &plpgsql_yystacksize);
	plpgsql_yyls = plpgsql_yyls1;
# else
	plpgsql_yyoverflow ("parser stack overflow",
		    &plpgsql_yyss1, plpgsql_yysize * sizeof (*plpgsql_yyssp),
		    &plpgsql_yyvs1, plpgsql_yysize * sizeof (*plpgsql_yyvsp),
		    &plpgsql_yystacksize);
# endif
	plpgsql_yyss = plpgsql_yyss1;
	plpgsql_yyvs = plpgsql_yyvs1;
      }
#else /* no plpgsql_yyoverflow */
# ifndef PLPGSQL_YYSTACK_RELOCATE
      goto plpgsql_yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (plpgsql_yystacksize >= PLPGSQL_YYMAXDEPTH)
	goto plpgsql_yyoverflowlab;
      plpgsql_yystacksize *= 2;
      if (plpgsql_yystacksize > PLPGSQL_YYMAXDEPTH)
	plpgsql_yystacksize = PLPGSQL_YYMAXDEPTH;

      {
	short *plpgsql_yyss1 = plpgsql_yyss;
	union plpgsql_yyalloc *plpgsql_yyptr =
	  (union plpgsql_yyalloc *) PLPGSQL_YYSTACK_ALLOC (PLPGSQL_YYSTACK_BYTES (plpgsql_yystacksize));
	if (! plpgsql_yyptr)
	  goto plpgsql_yyoverflowlab;
	PLPGSQL_YYSTACK_RELOCATE (plpgsql_yyss);
	PLPGSQL_YYSTACK_RELOCATE (plpgsql_yyvs);
# if PLPGSQL_YYLSP_NEEDED
	PLPGSQL_YYSTACK_RELOCATE (plpgsql_yyls);
# endif
# undef PLPGSQL_YYSTACK_RELOCATE
	if (plpgsql_yyss1 != plpgsql_yyssa)
	  PLPGSQL_YYSTACK_FREE (plpgsql_yyss1);
      }
# endif
#endif /* no plpgsql_yyoverflow */

      plpgsql_yyssp = plpgsql_yyss + plpgsql_yysize - 1;
      plpgsql_yyvsp = plpgsql_yyvs + plpgsql_yysize - 1;
#if PLPGSQL_YYLSP_NEEDED
      plpgsql_yylsp = plpgsql_yyls + plpgsql_yysize - 1;
#endif

      PLPGSQL_YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) plpgsql_yystacksize));

      if (plpgsql_yyssp >= plpgsql_yyss + plpgsql_yystacksize - 1)
	PLPGSQL_YYABORT;
    }

  PLPGSQL_YYDPRINTF ((stderr, "Entering state %d\n", plpgsql_yystate));

  goto plpgsql_yybackup;


/*-----------.
| plpgsql_yybackup.  |
`-----------*/
plpgsql_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* plpgsql_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];
  if (plpgsql_yyn == PLPGSQL_YYFLAG)
    goto plpgsql_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* plpgsql_yychar is either PLPGSQL_YYEMPTY or PLPGSQL_YYEOF
     or a valid token in external form.  */

  if (plpgsql_yychar == PLPGSQL_YYEMPTY)
    {
      PLPGSQL_YYDPRINTF ((stderr, "Reading a token: "));
      plpgsql_yychar = PLPGSQL_YYLEX;
    }

  /* Convert token to internal form (in plpgsql_yychar1) for indexing tables with */

  if (plpgsql_yychar <= 0)		/* This means end of input. */
    {
      plpgsql_yychar1 = 0;
      plpgsql_yychar = PLPGSQL_YYEOF;		/* Don't call PLPGSQL_YYLEX any more */

      PLPGSQL_YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      plpgsql_yychar1 = PLPGSQL_YYTRANSLATE (plpgsql_yychar);

#if PLPGSQL_YYDEBUG
     /* We have to keep this `#if PLPGSQL_YYDEBUG', since we use variables
	which are defined only if `PLPGSQL_YYDEBUG' is set.  */
      if (plpgsql_yydebug)
	{
	  PLPGSQL_YYFPRINTF (stderr, "Next token is %d (%s",
		     plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef PLPGSQL_YYPRINT
	  PLPGSQL_YYPRINT (stderr, plpgsql_yychar, plpgsql_yylval);
# endif
	  PLPGSQL_YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  plpgsql_yyn += plpgsql_yychar1;
  if (plpgsql_yyn < 0 || plpgsql_yyn > PLPGSQL_YYLAST || plpgsql_yycheck[plpgsql_yyn] != plpgsql_yychar1)
    goto plpgsql_yydefault;

  plpgsql_yyn = plpgsql_yytable[plpgsql_yyn];

  /* plpgsql_yyn is what to do for this token type in this state.
     Negative => reduce, -plpgsql_yyn is rule number.
     Positive => shift, plpgsql_yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (plpgsql_yyn < 0)
    {
      if (plpgsql_yyn == PLPGSQL_YYFLAG)
	goto plpgsql_yyerrlab;
      plpgsql_yyn = -plpgsql_yyn;
      goto plpgsql_yyreduce;
    }
  else if (plpgsql_yyn == 0)
    goto plpgsql_yyerrlab;

  if (plpgsql_yyn == PLPGSQL_YYFINAL)
    PLPGSQL_YYACCEPT;

  /* Shift the lookahead token.  */
  PLPGSQL_YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (plpgsql_yychar != PLPGSQL_YYEOF)
    plpgsql_yychar = PLPGSQL_YYEMPTY;

  *++plpgsql_yyvsp = plpgsql_yylval;
#if PLPGSQL_YYLSP_NEEDED
  *++plpgsql_yylsp = plpgsql_yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (plpgsql_yyerrstatus)
    plpgsql_yyerrstatus--;

  plpgsql_yystate = plpgsql_yyn;
  goto plpgsql_yynewstate;


/*-----------------------------------------------------------.
| plpgsql_yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
plpgsql_yydefault:
  plpgsql_yyn = plpgsql_yydefact[plpgsql_yystate];
  if (plpgsql_yyn == 0)
    goto plpgsql_yyerrlab;
  goto plpgsql_yyreduce;


/*-----------------------------.
| plpgsql_yyreduce -- Do a reduction.  |
`-----------------------------*/
plpgsql_yyreduce:
  /* plpgsql_yyn is the number of a rule to reduce with.  */
  plpgsql_yylen = plpgsql_yyr2[plpgsql_yyn];

  /* If PLPGSQL_YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets PLPGSQL_YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to PLPGSQL_YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that PLPGSQL_YYVAL may be used uninitialized.  */
  plpgsql_yyval = plpgsql_yyvsp[1-plpgsql_yylen];

#if PLPGSQL_YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  plpgsql_yyloc = plpgsql_yylsp[1-plpgsql_yylen];
  PLPGSQL_YYLLOC_DEFAULT (plpgsql_yyloc, (plpgsql_yylsp - plpgsql_yylen), plpgsql_yylen);
#endif

#if PLPGSQL_YYDEBUG
  /* We have to keep this `#if PLPGSQL_YYDEBUG', since we use variables which
     are defined only if `PLPGSQL_YYDEBUG' is set.  */
  if (plpgsql_yydebug)
    {
      int plpgsql_yyi;

      PLPGSQL_YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 plpgsql_yyn, plpgsql_yyrline[plpgsql_yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (plpgsql_yyi = plpgsql_yyprhs[plpgsql_yyn]; plpgsql_yyrhs[plpgsql_yyi] > 0; plpgsql_yyi++)
	PLPGSQL_YYFPRINTF (stderr, "%s ", plpgsql_yytname[plpgsql_yyrhs[plpgsql_yyi]]);
      PLPGSQL_YYFPRINTF (stderr, " -> %s\n", plpgsql_yytname[plpgsql_yyr1[plpgsql_yyn]]);
    }
#endif

  switch (plpgsql_yyn) {

case 1:
#line 212 "gram.y"
{
						plpgsql_yylval.program = (PLpgSQL_stmt_block *)plpgsql_yyvsp[-1].stmt;
					}
    break;
case 2:
#line 216 "gram.y"
{
						plpgsql_yylval.program = (PLpgSQL_stmt_block *)plpgsql_yyvsp[-1].stmt;
					}
    break;
case 7:
#line 230 "gram.y"
{
						plpgsql_DumpExecTree = 1;
					}
    break;
case 10:
#line 240 "gram.y"
{
						PLpgSQL_stmt_block *new;

						new = malloc(sizeof(PLpgSQL_stmt_block));
						memset(new, 0, sizeof(PLpgSQL_stmt_block));

						new->cmd_type	= PLPGSQL_STMT_BLOCK;
						new->lineno		= plpgsql_yyvsp[-2].ival;
						new->label		= plpgsql_yyvsp[-4].declhdr.label;
						new->n_initvars = plpgsql_yyvsp[-4].declhdr.n_initvars;
						new->initvarnos = plpgsql_yyvsp[-4].declhdr.initvarnos;
						new->body		= plpgsql_yyvsp[-1].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 11:
#line 261 "gram.y"
{
						plpgsql_ns_setlocal(false);
						plpgsql_yyval.declhdr.label	  = plpgsql_yyvsp[0].str;
						plpgsql_yyval.declhdr.n_initvars = 0;
						plpgsql_yyval.declhdr.initvarnos = NULL;
						plpgsql_add_initdatums(NULL);
					}
    break;
case 12:
#line 269 "gram.y"
{
						plpgsql_ns_setlocal(false);
						plpgsql_yyval.declhdr.label	  = plpgsql_yyvsp[-1].str;
						plpgsql_yyval.declhdr.n_initvars = 0;
						plpgsql_yyval.declhdr.initvarnos = NULL;
						plpgsql_add_initdatums(NULL);
					}
    break;
case 13:
#line 277 "gram.y"
{
						plpgsql_ns_setlocal(false);
						if (plpgsql_yyvsp[0].str != NULL)
							plpgsql_yyval.declhdr.label = plpgsql_yyvsp[0].str;
						else
							plpgsql_yyval.declhdr.label = plpgsql_yyvsp[-2].str;
						plpgsql_yyval.declhdr.n_initvars = plpgsql_add_initdatums(&(plpgsql_yyval.declhdr.initvarnos));
					}
    break;
case 14:
#line 288 "gram.y"
{
						plpgsql_ns_setlocal(true);
					}
    break;
case 15:
#line 294 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[0].str;	}
    break;
case 16:
#line 296 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[0].str;	}
    break;
case 17:
#line 300 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[-2].str;	}
    break;
case 18:
#line 302 "gram.y"
{	plpgsql_yyval.str = NULL;	}
    break;
case 19:
#line 304 "gram.y"
{	plpgsql_yyval.str = NULL;	}
    break;
case 20:
#line 308 "gram.y"
{
						PLpgSQL_var		*new;

						new = malloc(sizeof(PLpgSQL_var));
						memset(new, 0, sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[-4].varname.name;
						new->lineno		= plpgsql_yyvsp[-4].varname.lineno;

						new->datatype	= plpgsql_yyvsp[-2].dtype;
						new->isconst	= plpgsql_yyvsp[-3].ival;
						new->notnull	= plpgsql_yyvsp[-1].ival;
						new->default_val = plpgsql_yyvsp[0].expr;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
												plpgsql_yyvsp[-4].varname.name);
					}
    break;
case 21:
#line 328 "gram.y"
{
						PLpgSQL_rec		*new;

						new = malloc(sizeof(PLpgSQL_rec));

						new->dtype		= PLPGSQL_DTYPE_REC;
						new->refname	= plpgsql_yyvsp[-2].varname.name;
						new->lineno		= plpgsql_yyvsp[-2].varname.lineno;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, new->recno,
												plpgsql_yyvsp[-2].varname.name);
					}
    break;
case 22:
#line 342 "gram.y"
{
						plpgsql_yyvsp[-1].row->dtype		= PLPGSQL_DTYPE_ROW;
						plpgsql_yyvsp[-1].row->refname		= plpgsql_yyvsp[-2].varname.name;
						plpgsql_yyvsp[-1].row->lineno		= plpgsql_yyvsp[-2].varname.lineno;

						plpgsql_adddatum((PLpgSQL_datum *)plpgsql_yyvsp[-1].row);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_ROW, plpgsql_yyvsp[-1].row->rowno,
												plpgsql_yyvsp[-2].varname.name);
					}
    break;
case 23:
#line 352 "gram.y"
{
						plpgsql_ns_additem(plpgsql_yyvsp[-1].nsitem->itemtype,
										plpgsql_yyvsp[-1].nsitem->itemno, plpgsql_yyvsp[-4].varname.name);
					}
    break;
case 24:
#line 357 "gram.y"
{
						plpgsql_ns_rename(plpgsql_yyvsp[-3].str, plpgsql_yyvsp[-1].str);
					}
    break;
case 25:
#line 361 "gram.y"
{ plpgsql_ns_push(NULL); }
    break;
case 26:
#line 363 "gram.y"
{
						PLpgSQL_var *new;
						PLpgSQL_expr *curname_def;
						char		buf[1024];
						char		*cp1;
						char		*cp2;

						/* pop local namespace for cursor args */
						plpgsql_ns_pop();

						new = malloc(sizeof(PLpgSQL_var));
						memset(new, 0, sizeof(PLpgSQL_var));

						curname_def = malloc(sizeof(PLpgSQL_expr));
						memset(curname_def, 0, sizeof(PLpgSQL_expr));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[-6].varname.name;
						new->lineno		= plpgsql_yyvsp[-6].varname.lineno;

						curname_def->dtype = PLPGSQL_DTYPE_EXPR;
						strcpy(buf, "SELECT '");
						cp1 = new->refname;
						cp2 = buf + strlen(buf);
						while (*cp1 != '\0')
						{
							if (*cp1 == '\\' || *cp1 == '\'')
								*cp2++ = '\\';
							*cp2++ = *cp1++;
						}
						strcpy(cp2, "'::refcursor");
						curname_def->query = strdup(buf);
						new->default_val = curname_def;

						new->datatype = plpgsql_parse_datatype("refcursor");

						new->cursor_explicit_expr = plpgsql_yyvsp[0].expr;
						if (plpgsql_yyvsp[-3].row == NULL)
							new->cursor_explicit_argrow = -1;
						else
							new->cursor_explicit_argrow = plpgsql_yyvsp[-3].row->rowno;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
										   plpgsql_yyvsp[-6].varname.name);
					}
    break;
case 27:
#line 412 "gram.y"
{
						PLpgSQL_expr *query;

						plpgsql_ns_setlocal(false);
						query = read_sql_stmt("SELECT ");
						plpgsql_ns_setlocal(true);
						
						plpgsql_yyval.expr = query;
					}
    break;
case 28:
#line 424 "gram.y"
{
						plpgsql_yyval.row = NULL;
					}
    break;
case 29:
#line 428 "gram.y"
{
						/* Copy the temp arrays to malloc'd storage */
						int nfields = plpgsql_yyvsp[-1].row->nfields;
						char **ftmp;
						int *vtmp;

						ftmp = malloc(nfields * sizeof(char *));
						vtmp = malloc(nfields * sizeof(int));
						memcpy(ftmp, plpgsql_yyvsp[-1].row->fieldnames, nfields * sizeof(char *));
						memcpy(vtmp, plpgsql_yyvsp[-1].row->varnos, nfields * sizeof(int));

						pfree((char *)(plpgsql_yyvsp[-1].row->fieldnames));
						pfree((char *)(plpgsql_yyvsp[-1].row->varnos));

						plpgsql_yyvsp[-1].row->fieldnames = ftmp;
						plpgsql_yyvsp[-1].row->varnos = vtmp;

						plpgsql_adddatum((PLpgSQL_datum *)plpgsql_yyvsp[-1].row);

						plpgsql_yyval.row = plpgsql_yyvsp[-1].row;
					}
    break;
case 30:
#line 452 "gram.y"
{
						PLpgSQL_row *new;

						new = malloc(sizeof(PLpgSQL_row));
						memset(new, 0, sizeof(PLpgSQL_row));

						new->dtype = PLPGSQL_DTYPE_ROW;
						new->refname = strdup("*internal*");
						new->lineno = plpgsql_yylineno;
						new->rowtypeclass = InvalidOid;
						/*
						 * We make temporary fieldnames/varnos arrays that
						 * are much bigger than necessary.  We will resize
						 * them to just the needed size in the
						 * decl_cursor_args production.
						 */
						new->fieldnames = palloc(1024 * sizeof(char *));
						new->varnos = palloc(1024 * sizeof(int));
						new->nfields = 1;

						new->fieldnames[0] = plpgsql_yyvsp[0].var->refname;
						new->varnos[0] = plpgsql_yyvsp[0].var->varno;

						plpgsql_yyval.row = new;
					}
    break;
case 31:
#line 478 "gram.y"
{
						int i = plpgsql_yyvsp[-2].row->nfields++;

						plpgsql_yyvsp[-2].row->fieldnames[i] = plpgsql_yyvsp[0].var->refname;
						plpgsql_yyvsp[-2].row->varnos[i] = plpgsql_yyvsp[0].var->varno;

						plpgsql_yyval.row = plpgsql_yyvsp[-2].row;
					}
    break;
case 32:
#line 489 "gram.y"
{
						PLpgSQL_var *new;

						new = malloc(sizeof(PLpgSQL_var));
						memset(new, 0, sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[-1].varname.name;
						new->lineno		= plpgsql_yyvsp[-1].varname.lineno;

						new->datatype	= plpgsql_yyvsp[0].dtype;
						new->isconst	= false;
						new->notnull	= false;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
										   plpgsql_yyvsp[-1].varname.name);
						
						plpgsql_yyval.var = new;
					}
    break;
case 35:
#line 515 "gram.y"
{
						char	*name;
						PLpgSQL_nsitem *nsi;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						if (name[0] != '$')
							plpgsql_yyerror("can only alias positional parameters");

						plpgsql_ns_setlocal(false);
						nsi = plpgsql_ns_lookup(name, NULL);
						if (nsi == NULL)
						{
							plpgsql_error_lineno = plpgsql_yylineno;
							elog(ERROR, "function has no parameter %s", name);
						}

						plpgsql_ns_setlocal(true);

						pfree(name);

						plpgsql_yyval.nsitem = nsi;
					}
    break;
case 36:
#line 540 "gram.y"
{
						plpgsql_yyval.row = plpgsql_yylval.row;
					}
    break;
case 37:
#line 546 "gram.y"
{
						char	*name;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						/* name should be malloc'd for use as varname */
						plpgsql_yyval.varname.name = strdup(name);
						plpgsql_yyval.varname.lineno  = plpgsql_yylineno;
						pfree(name);
					}
    break;
case 38:
#line 558 "gram.y"
{
						char	*name;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						/* the result must be palloc'd, see plpgsql_ns_rename */
						plpgsql_yyval.str = name;
					}
    break;
case 39:
#line 568 "gram.y"
{ plpgsql_yyval.ival = 0; }
    break;
case 40:
#line 570 "gram.y"
{ plpgsql_yyval.ival = 1; }
    break;
case 41:
#line 574 "gram.y"
{
						/*
						 * If there's a lookahead token, read_datatype
						 * should consume it.
						 */
						plpgsql_yyval.dtype = read_datatype(plpgsql_yychar);
						plpgsql_yyclearin;
					}
    break;
case 42:
#line 585 "gram.y"
{ plpgsql_yyval.ival = 0; }
    break;
case 43:
#line 587 "gram.y"
{ plpgsql_yyval.ival = 1; }
    break;
case 44:
#line 591 "gram.y"
{ plpgsql_yyval.expr = NULL; }
    break;
case 45:
#line 593 "gram.y"
{
						int				tok;
						int				lno;
						PLpgSQL_dstring ds;
						PLpgSQL_expr	*expr;

						lno = plpgsql_yylineno;
						expr = malloc(sizeof(PLpgSQL_expr));
						plpgsql_dstring_init(&ds);
						plpgsql_dstring_append(&ds, "SELECT ");

						expr->dtype   = PLPGSQL_DTYPE_EXPR;
						expr->plan	  = NULL;
						expr->nparams = 0;

						tok = plpgsql_yylex();
						switch (tok)
						{
							case 0:
								plpgsql_yyerror("unexpected end of file");
							case K_NULL:
								if (plpgsql_yylex() != ';')
									plpgsql_yyerror("expected ; after NULL");

								free(expr);
								plpgsql_dstring_free(&ds);

								plpgsql_yyval.expr = NULL;
								break;

							default:
								plpgsql_dstring_append(&ds, plpgsql_yytext);
								while ((tok = plpgsql_yylex()) != ';')
								{
									if (tok == 0)
										plpgsql_yyerror("unterminated default value");

									if (plpgsql_SpaceScanned)
										plpgsql_dstring_append(&ds, " ");
									plpgsql_dstring_append(&ds, plpgsql_yytext);
								}
								expr->query = strdup(plpgsql_dstring_get(&ds));
								plpgsql_dstring_free(&ds);

								plpgsql_yyval.expr = expr;
								break;
						}
					}
    break;
case 48:
#line 648 "gram.y"
{
							PLpgSQL_stmts	*new;

							new = malloc(sizeof(PLpgSQL_stmts));
							memset(new, 0, sizeof(PLpgSQL_stmts));
							plpgsql_yyval.stmts = new;
					}
    break;
case 49:
#line 656 "gram.y"
{ plpgsql_yyval.stmts = plpgsql_yyvsp[0].stmts; }
    break;
case 50:
#line 660 "gram.y"
{
								if (plpgsql_yyvsp[-1].stmts->stmts_used == plpgsql_yyvsp[-1].stmts->stmts_alloc)
								{
									plpgsql_yyvsp[-1].stmts->stmts_alloc *= 2;
									plpgsql_yyvsp[-1].stmts->stmts = realloc(plpgsql_yyvsp[-1].stmts->stmts, sizeof(PLpgSQL_stmt *) * plpgsql_yyvsp[-1].stmts->stmts_alloc);
								}
								plpgsql_yyvsp[-1].stmts->stmts[plpgsql_yyvsp[-1].stmts->stmts_used++] = (struct PLpgSQL_stmt *)plpgsql_yyvsp[0].stmt;

								plpgsql_yyval.stmts = plpgsql_yyvsp[-1].stmts;
						}
    break;
case 51:
#line 671 "gram.y"
{
								PLpgSQL_stmts	*new;

								new = malloc(sizeof(PLpgSQL_stmts));
								memset(new, 0, sizeof(PLpgSQL_stmts));

								new->stmts_alloc = 64;
								new->stmts_used  = 1;
								new->stmts = malloc(sizeof(PLpgSQL_stmt *) * new->stmts_alloc);
								new->stmts[0] = (struct PLpgSQL_stmt *)plpgsql_yyvsp[0].stmt;

								plpgsql_yyval.stmts = new;

						}
    break;
case 52:
#line 688 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[-1].stmt; }
    break;
case 53:
#line 690 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 54:
#line 692 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 55:
#line 694 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 56:
#line 696 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 57:
#line 698 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 58:
#line 700 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 59:
#line 702 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 60:
#line 704 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 61:
#line 706 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 62:
#line 708 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 63:
#line 710 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 64:
#line 712 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 65:
#line 714 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 66:
#line 716 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 67:
#line 718 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 68:
#line 720 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 69:
#line 722 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 70:
#line 724 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 71:
#line 726 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; }
    break;
case 72:
#line 730 "gram.y"
{
						PLpgSQL_stmt_assign *new;

						new = malloc(sizeof(PLpgSQL_stmt_assign));
						memset(new, 0, sizeof(PLpgSQL_stmt_assign));

						new->cmd_type = PLPGSQL_STMT_ASSIGN;
						new->lineno   = plpgsql_yyvsp[-1].ival;
						new->varno = -1;
						new->expr  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 73:
#line 746 "gram.y"
{
						PLpgSQL_stmt_assign *new;

						new = malloc(sizeof(PLpgSQL_stmt_assign));
						memset(new, 0, sizeof(PLpgSQL_stmt_assign));

						new->cmd_type = PLPGSQL_STMT_ASSIGN;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->varno = plpgsql_yyvsp[-3].ival;
						new->expr  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 74:
#line 762 "gram.y"
{
						PLpgSQL_stmt_getdiag	 *new;

						new = malloc(sizeof(PLpgSQL_stmt_getdiag));
						memset(new, 0, sizeof(PLpgSQL_stmt_getdiag));

						new->cmd_type = PLPGSQL_STMT_GETDIAG;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->ndtitems = plpgsql_yyvsp[-1].dtlist.nused;
						new->dtitems  = malloc(sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-1].dtlist.nused);
						memcpy(new->dtitems, plpgsql_yyvsp[-1].dtlist.dtitems, sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-1].dtlist.nused);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 75:
#line 779 "gram.y"
{
						if (plpgsql_yyvsp[-4].dtlist.nused == plpgsql_yyvsp[-4].dtlist.nalloc)
						{
							plpgsql_yyvsp[-4].dtlist.nalloc *= 2;
							plpgsql_yyvsp[-4].dtlist.dtitems = repalloc(plpgsql_yyvsp[-4].dtlist.dtitems, sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-4].dtlist.nalloc);
						}
						plpgsql_yyvsp[-4].dtlist.dtitems[plpgsql_yyvsp[-4].dtlist.nused].target = plpgsql_yyvsp[-2].ival;
						plpgsql_yyvsp[-4].dtlist.dtitems[plpgsql_yyvsp[-4].dtlist.nused].item   = plpgsql_yyvsp[0].ival;
						plpgsql_yyvsp[-4].dtlist.nused++;

						plpgsql_yyval.dtlist.nalloc = plpgsql_yyvsp[-4].dtlist.nalloc;
						plpgsql_yyval.dtlist.nused  = plpgsql_yyvsp[-4].dtlist.nused;
						plpgsql_yyval.dtlist.dtitems = plpgsql_yyvsp[-4].dtlist.dtitems;
					}
    break;
case 76:
#line 794 "gram.y"
{
						plpgsql_yyval.dtlist.nalloc = 1;
						plpgsql_yyval.dtlist.nused  = 1;
						plpgsql_yyval.dtlist.dtitems = palloc(sizeof(PLpgSQL_diag_item) * plpgsql_yyval.dtlist.nalloc);
						plpgsql_yyval.dtlist.dtitems[0].target = plpgsql_yyvsp[-2].ival;
						plpgsql_yyval.dtlist.dtitems[0].item   = plpgsql_yyvsp[0].ival;
					}
    break;
case 77:
#line 804 "gram.y"
{
						plpgsql_yyval.ival = PLPGSQL_GETDIAG_ROW_COUNT;
					}
    break;
case 78:
#line 808 "gram.y"
{
						plpgsql_yyval.ival = PLPGSQL_GETDIAG_RESULT_OID;
					}
    break;
case 79:
#line 814 "gram.y"
{
						check_assignable(plpgsql_yylval.variable);
						plpgsql_yyval.ival = plpgsql_yylval.variable->dno;
					}
    break;
case 80:
#line 822 "gram.y"
{
						check_assignable(plpgsql_yylval.variable);
						plpgsql_yyval.ival = plpgsql_yylval.variable->dno;
					}
    break;
case 81:
#line 829 "gram.y"
{
						PLpgSQL_stmt_if *new;

						new = malloc(sizeof(PLpgSQL_stmt_if));
						memset(new, 0, sizeof(PLpgSQL_stmt_if));

						new->cmd_type	= PLPGSQL_STMT_IF;
						new->lineno		= plpgsql_yyvsp[-6].ival;
						new->cond		= plpgsql_yyvsp[-5].expr;
						new->true_body	= plpgsql_yyvsp[-4].stmts;
						new->false_body = plpgsql_yyvsp[-3].stmts;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 82:
#line 846 "gram.y"
{
							PLpgSQL_stmts	*new;

							new = malloc(sizeof(PLpgSQL_stmts));
							memset(new, 0, sizeof(PLpgSQL_stmts));
							plpgsql_yyval.stmts = new;
					}
    break;
case 83:
#line 854 "gram.y"
{
					  /*
					   * Translate the structure:	   into:
					   *
					   * IF c1 THEN					   IF c1 THEN		 
					   *	 ...						   ...				 
					   * ELSIF c2 THEN				   ELSE 
					   *								   IF c2 THEN	
					   *	 ...							   ...				 
					   * ELSE							   ELSE				 
					   *	 ...							   ...				 
					   * END IF							   END IF			 
					   *							   END IF
					   * 
					   */

						PLpgSQL_stmts	*new;
						PLpgSQL_stmt_if *new_if;

						/* first create a new if-statement */
						new_if = malloc(sizeof(PLpgSQL_stmt_if));
						memset(new_if, 0, sizeof(PLpgSQL_stmt_if));

						new_if->cmd_type	= PLPGSQL_STMT_IF;
						new_if->lineno		= plpgsql_yyvsp[-3].ival;
						new_if->cond		= plpgsql_yyvsp[-2].expr;
						new_if->true_body	= plpgsql_yyvsp[-1].stmts;
						new_if->false_body	= plpgsql_yyvsp[0].stmts;
						
						/* this is a 'container' for the if-statement */
						new = malloc(sizeof(PLpgSQL_stmts));
						memset(new, 0, sizeof(PLpgSQL_stmts));
						
						new->stmts_alloc = 64;
						new->stmts_used	 = 1;
						new->stmts = malloc(sizeof(PLpgSQL_stmt *) * new->stmts_alloc);
						new->stmts[0] = (struct PLpgSQL_stmt *)new_if;

						plpgsql_yyval.stmts = new;
						
					}
    break;
case 84:
#line 897 "gram.y"
{
						plpgsql_yyval.stmts = plpgsql_yyvsp[0].stmts;				
					}
    break;
case 85:
#line 903 "gram.y"
{
						PLpgSQL_stmt_loop *new;

						new = malloc(sizeof(PLpgSQL_stmt_loop));
						memset(new, 0, sizeof(PLpgSQL_stmt_loop));

						new->cmd_type = PLPGSQL_STMT_LOOP;
						new->lineno   = plpgsql_yyvsp[-1].ival;
						new->label	  = plpgsql_yyvsp[-3].str;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 86:
#line 921 "gram.y"
{
						PLpgSQL_stmt_while *new;

						new = malloc(sizeof(PLpgSQL_stmt_while));
						memset(new, 0, sizeof(PLpgSQL_stmt_while));

						new->cmd_type = PLPGSQL_STMT_WHILE;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->label	  = plpgsql_yyvsp[-4].str;
						new->cond	  = plpgsql_yyvsp[-1].expr;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 87:
#line 940 "gram.y"
{
						PLpgSQL_stmt_fori		*new;

						new = malloc(sizeof(PLpgSQL_stmt_fori));
						memset(new, 0, sizeof(PLpgSQL_stmt_fori));

						new->cmd_type = PLPGSQL_STMT_FORI;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						new->var	  = plpgsql_yyvsp[-4].var;
						new->reverse  = plpgsql_yyvsp[-2].forilow.reverse;
						new->lower	  = plpgsql_yyvsp[-2].forilow.expr;
						new->upper	  = plpgsql_yyvsp[-1].expr;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 88:
#line 962 "gram.y"
{
						PLpgSQL_var		*new;

						new = malloc(sizeof(PLpgSQL_var));
						memset(new, 0, sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[0].varname.name;
						new->lineno		= plpgsql_yyvsp[0].varname.lineno;

						new->datatype	= plpgsql_parse_datatype("integer");
						new->isconst	= false;
						new->notnull	= false;
						new->default_val = NULL;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
												plpgsql_yyvsp[0].varname.name);

						plpgsql_add_initdatums(NULL);

						plpgsql_yyval.var = new;
					}
    break;
case 89:
#line 988 "gram.y"
{
						char	*name;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						/* name should be malloc'd for use as varname */
						plpgsql_yyval.varname.name = strdup(name);
						plpgsql_yyval.varname.lineno  = plpgsql_yylineno;
						pfree(name);
					}
    break;
case 90:
#line 998 "gram.y"
{
						char	*name;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						/* name should be malloc'd for use as varname */
						plpgsql_yyval.varname.name = strdup(name);
						plpgsql_yyval.varname.lineno  = plpgsql_yylineno;
						pfree(name);
					}
    break;
case 91:
#line 1010 "gram.y"
{
						int			tok;

						tok = plpgsql_yylex();
						if (tok == K_REVERSE)
						{
							plpgsql_yyval.forilow.reverse = 1;
						}
						else
						{
							plpgsql_yyval.forilow.reverse = 0;
							plpgsql_push_back_token(tok);
						}

						plpgsql_yyval.forilow.expr = plpgsql_read_expression(K_DOTDOT, "..");
					}
    break;
case 92:
#line 1029 "gram.y"
{
						PLpgSQL_stmt_fors		*new;

						new = malloc(sizeof(PLpgSQL_stmt_fors));
						memset(new, 0, sizeof(PLpgSQL_stmt_fors));

						new->cmd_type = PLPGSQL_STMT_FORS;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						switch (plpgsql_yyvsp[-4].rec->dtype)
						{
							case PLPGSQL_DTYPE_REC:
								new->rec = plpgsql_yyvsp[-4].rec;
								break;
							case PLPGSQL_DTYPE_ROW:
								new->row = (PLpgSQL_row *)plpgsql_yyvsp[-4].rec;
								break;
							default:
								elog(ERROR, "unknown dtype %d in stmt_fors", plpgsql_yyvsp[-4].rec->dtype);
						}
						new->query = plpgsql_yyvsp[-1].expr;
						new->body  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 93:
#line 1059 "gram.y"
{
						PLpgSQL_stmt_dynfors	*new;

						new = malloc(sizeof(PLpgSQL_stmt_dynfors));
						memset(new, 0, sizeof(PLpgSQL_stmt_dynfors));

						new->cmd_type = PLPGSQL_STMT_DYNFORS;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						switch (plpgsql_yyvsp[-4].rec->dtype)
						{
							case PLPGSQL_DTYPE_REC:
								new->rec = plpgsql_yyvsp[-4].rec;
								break;
							case PLPGSQL_DTYPE_ROW:
								new->row = (PLpgSQL_row *)plpgsql_yyvsp[-4].rec;
								break;
							default:
								elog(ERROR, "unknown dtype %d in stmt_dynfors", plpgsql_yyvsp[-4].rec->dtype);
						}
						new->query = plpgsql_yyvsp[-1].expr;
						new->body  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 94:
#line 1089 "gram.y"
{ plpgsql_yyval.rec = plpgsql_yylval.rec; }
    break;
case 95:
#line 1091 "gram.y"
{
						plpgsql_yyval.rec = (PLpgSQL_rec *)(plpgsql_yylval.row);
					}
    break;
case 96:
#line 1097 "gram.y"
{
						plpgsql_yyval.stmt = make_select_stmt();
						plpgsql_yyval.stmt->lineno = plpgsql_yyvsp[0].ival;
					}
    break;
case 97:
#line 1104 "gram.y"
{
						PLpgSQL_stmt_exit *new;

						new = malloc(sizeof(PLpgSQL_stmt_exit));
						memset(new, 0, sizeof(PLpgSQL_stmt_exit));

						new->cmd_type = PLPGSQL_STMT_EXIT;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->label	  = plpgsql_yyvsp[-1].str;
						new->cond	  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 98:
#line 1120 "gram.y"
{
						PLpgSQL_stmt_return *new;

						new = malloc(sizeof(PLpgSQL_stmt_return));
						memset(new, 0, sizeof(PLpgSQL_stmt_return));

						if (plpgsql_curr_compile->fn_retistuple &&
							!plpgsql_curr_compile->fn_retset)
						{
							new->retrecno	= -1;
							switch (plpgsql_yylex())
							{
								case K_NULL:
									new->expr = NULL;
									break;

								case T_ROW:
									new->expr = make_tupret_expr(plpgsql_yylval.row);
									break;

								case T_RECORD:
									new->retrecno = plpgsql_yylval.rec->recno;
									new->expr = NULL;
									break;

								default:
									plpgsql_yyerror("return type mismatch in function returning tuple");
									break;
							}
							if (plpgsql_yylex() != ';')
								plpgsql_yyerror("expected ';'");
						}
						else
							new->expr = plpgsql_read_expression(';', ";");

						new->cmd_type = PLPGSQL_STMT_RETURN;
						new->lineno   = plpgsql_yyvsp[0].ival;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 99:
#line 1163 "gram.y"
{
						PLpgSQL_stmt_return_next *new;

						new = malloc(sizeof(PLpgSQL_stmt_return_next));
						memset(new, 0, sizeof(PLpgSQL_stmt_return_next));

						new->cmd_type	= PLPGSQL_STMT_RETURN_NEXT;
						new->lineno		= plpgsql_yyvsp[0].ival;

						if (plpgsql_curr_compile->fn_retistuple)
						{
							int tok = plpgsql_yylex();

							if (tok == T_RECORD)
								new->rec = plpgsql_yylval.rec;
							else if (tok == T_ROW)
								new->row = plpgsql_yylval.row;
							else
								plpgsql_yyerror("Incorrect argument to RETURN NEXT");

							if (plpgsql_yylex() != ';')
								plpgsql_yyerror("Expected ';'");
						}
						else
							new->expr = plpgsql_read_expression(';', ";");

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 100:
#line 1194 "gram.y"
{
						PLpgSQL_stmt_raise		*new;

						new = malloc(sizeof(PLpgSQL_stmt_raise));

						new->cmd_type	= PLPGSQL_STMT_RAISE;
						new->lineno		= plpgsql_yyvsp[-4].ival;
						new->elog_level = plpgsql_yyvsp[-3].ival;
						new->message	= plpgsql_yyvsp[-2].str;
						new->nparams	= plpgsql_yyvsp[-1].intlist.nused;
						new->params		= malloc(sizeof(int) * plpgsql_yyvsp[-1].intlist.nused);
						memcpy(new->params, plpgsql_yyvsp[-1].intlist.nums, sizeof(int) * plpgsql_yyvsp[-1].intlist.nused);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 101:
#line 1210 "gram.y"
{
						PLpgSQL_stmt_raise		*new;

						new = malloc(sizeof(PLpgSQL_stmt_raise));

						new->cmd_type	= PLPGSQL_STMT_RAISE;
						new->lineno		= plpgsql_yyvsp[-3].ival;
						new->elog_level = plpgsql_yyvsp[-2].ival;
						new->message	= plpgsql_yyvsp[-1].str;
						new->nparams	= 0;
						new->params		= NULL;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 102:
#line 1227 "gram.y"
{
						plpgsql_yyval.str = strdup(plpgsql_yytext);
					}
    break;
case 103:
#line 1233 "gram.y"
{
						plpgsql_yyval.ival = ERROR;
					}
    break;
case 104:
#line 1237 "gram.y"
{
						plpgsql_yyval.ival = WARNING;
					}
    break;
case 105:
#line 1241 "gram.y"
{
						plpgsql_yyval.ival = NOTICE;
					}
    break;
case 106:
#line 1245 "gram.y"
{
						plpgsql_yyval.ival = INFO;
					}
    break;
case 107:
#line 1249 "gram.y"
{
						plpgsql_yyval.ival = LOG;
					}
    break;
case 108:
#line 1253 "gram.y"
{
						plpgsql_yyval.ival = DEBUG1;
					}
    break;
case 109:
#line 1259 "gram.y"
{
						if (plpgsql_yyvsp[-1].intlist.nused == plpgsql_yyvsp[-1].intlist.nalloc)
						{
							plpgsql_yyvsp[-1].intlist.nalloc *= 2;
							plpgsql_yyvsp[-1].intlist.nums = repalloc(plpgsql_yyvsp[-1].intlist.nums, sizeof(int) * plpgsql_yyvsp[-1].intlist.nalloc);
						}
						plpgsql_yyvsp[-1].intlist.nums[plpgsql_yyvsp[-1].intlist.nused++] = plpgsql_yyvsp[0].ival;

						plpgsql_yyval.intlist.nalloc = plpgsql_yyvsp[-1].intlist.nalloc;
						plpgsql_yyval.intlist.nused  = plpgsql_yyvsp[-1].intlist.nused;
						plpgsql_yyval.intlist.nums   = plpgsql_yyvsp[-1].intlist.nums;
					}
    break;
case 110:
#line 1272 "gram.y"
{
						plpgsql_yyval.intlist.nalloc = 1;
						plpgsql_yyval.intlist.nused  = 1;
						plpgsql_yyval.intlist.nums   = palloc(sizeof(int) * plpgsql_yyval.intlist.nalloc);
						plpgsql_yyval.intlist.nums[0] = plpgsql_yyvsp[0].ival;
					}
    break;
case 111:
#line 1281 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.variable->dno;
					}
    break;
case 112:
#line 1287 "gram.y"
{ plpgsql_yyval.stmts = plpgsql_yyvsp[-3].stmts; }
    break;
case 113:
#line 1291 "gram.y"
{
						PLpgSQL_stmt_execsql	*new;

						new = malloc(sizeof(PLpgSQL_stmt_execsql));
						new->cmd_type = PLPGSQL_STMT_EXECSQL;
						new->lineno   = plpgsql_yyvsp[0].ival;
						new->sqlstmt  = read_sql_stmt(plpgsql_yyvsp[-1].str);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 114:
#line 1304 "gram.y"
{
							PLpgSQL_stmt_dynexecute *new;

							new = malloc(sizeof(PLpgSQL_stmt_dynexecute));
							new->cmd_type = PLPGSQL_STMT_DYNEXECUTE;
							new->lineno   = plpgsql_yyvsp[-1].ival;
							new->query	  = plpgsql_yyvsp[0].expr;

							plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
						}
    break;
case 115:
#line 1317 "gram.y"
{
						PLpgSQL_stmt_open *new;
						int				  tok;

						new = malloc(sizeof(PLpgSQL_stmt_open));
						memset(new, 0, sizeof(PLpgSQL_stmt_open));

						new->cmd_type = PLPGSQL_STMT_OPEN;
						new->lineno = plpgsql_yyvsp[-1].ival;
						new->curvar = plpgsql_yyvsp[0].var->varno;

						if (plpgsql_yyvsp[0].var->cursor_explicit_expr == NULL)
						{
						    tok = plpgsql_yylex();

							if (tok != K_FOR)
							{
								plpgsql_error_lineno = plpgsql_yyvsp[-1].ival;
								elog(ERROR, "syntax error at \"%s\" - expected FOR to open a reference cursor", plpgsql_yytext);
							}

							tok = plpgsql_yylex();
							switch (tok)
							{
								case K_SELECT:
									new->query = read_sql_stmt("SELECT ");
									break;

								case K_EXECUTE:
									new->dynquery = read_sql_stmt("SELECT ");
									break;

								default:
									plpgsql_error_lineno = plpgsql_yyvsp[-1].ival;
									elog(ERROR, "syntax error at \"%s\"", plpgsql_yytext);
							}

						}
						else
						{
							if (plpgsql_yyvsp[0].var->cursor_explicit_argrow >= 0)
							{
								char   *cp;

								tok = plpgsql_yylex();

								if (tok != '(')
								{
									plpgsql_error_lineno = plpgsql_yylineno;
									elog(ERROR, "cursor %s has arguments",
										 plpgsql_yyvsp[0].var->refname);
								}

								/*
								 * Push back the '(', else read_sql_stmt
								 * will complain about unbalanced parens.
								 */
								plpgsql_push_back_token(tok);

								new->argquery = read_sql_stmt("SELECT ");

								/*
								 * Now remove the leading and trailing parens,
								 * because we want "select 1, 2", not
								 * "select (1, 2)".
								 */
								cp = new->argquery->query;

								if (strncmp(cp, "SELECT", 6) != 0)
								{
									plpgsql_error_lineno = plpgsql_yylineno;
									elog(ERROR, "expected 'SELECT (', got '%s' (internal error)",
										 new->argquery->query);
								}
								cp += 6;
								while (*cp == ' ') /* could be more than 1 space here */
									cp++;
								if (*cp != '(')
								{
									plpgsql_error_lineno = plpgsql_yylineno;
									elog(ERROR, "expected 'SELECT (', got '%s' (internal error)",
										 new->argquery->query);
								}
								*cp = ' ';

								cp += strlen(cp) - 1;

								if (*cp != ')')
									plpgsql_yyerror("missing )");
								*cp = '\0';
							}
							else
							{
								tok = plpgsql_yylex();

								if (tok == '(')
								{
									plpgsql_error_lineno = plpgsql_yylineno;
									elog(ERROR, "cursor %s has no arguments", plpgsql_yyvsp[0].var->refname);
								}
								
								if (tok != ';')
								{
									plpgsql_error_lineno = plpgsql_yylineno;
									elog(ERROR, "syntax error at \"%s\"", plpgsql_yytext);
								}
							}
						}

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 116:
#line 1431 "gram.y"
{
						PLpgSQL_stmt_fetch *new;

						new = (PLpgSQL_stmt_fetch *)make_fetch_stmt();
						new->curvar = plpgsql_yyvsp[-1].ival;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
						plpgsql_yyval.stmt->lineno = plpgsql_yyvsp[-2].ival;
					}
    break;
case 117:
#line 1443 "gram.y"
{
						PLpgSQL_stmt_close *new;

						new = malloc(sizeof(PLpgSQL_stmt_close));
						new->cmd_type = PLPGSQL_STMT_CLOSE;
						new->lineno = plpgsql_yyvsp[-2].ival;
						new->curvar = plpgsql_yyvsp[-1].ival;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					}
    break;
case 118:
#line 1456 "gram.y"
{
						if (plpgsql_yylval.variable->dtype != PLPGSQL_DTYPE_VAR)
							plpgsql_yyerror("cursor variable must be a simple variable");

						if (((PLpgSQL_var *) plpgsql_yylval.variable)->datatype->typoid != REFCURSOROID)
						{
							plpgsql_error_lineno = plpgsql_yylineno;
							elog(ERROR, "%s must be of type cursor or refcursor",
								 ((PLpgSQL_var *) plpgsql_yylval.variable)->refname);
						}
						plpgsql_yyval.var = (PLpgSQL_var *) plpgsql_yylval.variable;
					}
    break;
case 119:
#line 1471 "gram.y"
{
						if (plpgsql_yylval.variable->dtype != PLPGSQL_DTYPE_VAR)
							plpgsql_yyerror("cursor variable must be a simple variable");

						if (((PLpgSQL_var *) plpgsql_yylval.variable)->datatype->typoid != REFCURSOROID)
						{
							plpgsql_error_lineno = plpgsql_yylineno;
							elog(ERROR, "%s must be of type refcursor",
								 ((PLpgSQL_var *) plpgsql_yylval.variable)->refname);
						}
						plpgsql_yyval.ival = plpgsql_yylval.variable->dno;
					}
    break;
case 120:
#line 1486 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); }
    break;
case 121:
#line 1488 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); }
    break;
case 122:
#line 1492 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(';', ";"); }
    break;
case 123:
#line 1496 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(K_THEN, "THEN"); }
    break;
case 124:
#line 1500 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(K_LOOP, "LOOP"); }
    break;
case 125:
#line 1504 "gram.y"
{
						plpgsql_ns_push(NULL);
						plpgsql_yyval.str = NULL;
					}
    break;
case 126:
#line 1509 "gram.y"
{
						plpgsql_ns_push(plpgsql_yyvsp[-2].str);
						plpgsql_yyval.str = plpgsql_yyvsp[-2].str;
					}
    break;
case 127:
#line 1516 "gram.y"
{ plpgsql_yyval.str = NULL; }
    break;
case 128:
#line 1518 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); }
    break;
case 129:
#line 1522 "gram.y"
{ plpgsql_yyval.expr = NULL; }
    break;
case 130:
#line 1524 "gram.y"
{ plpgsql_yyval.expr = plpgsql_yyvsp[0].expr; }
    break;
case 131:
#line 1528 "gram.y"
{
						char	*name;

						plpgsql_convert_ident(plpgsql_yytext, &name, 1);
						plpgsql_yyval.str = strdup(name);
						pfree(name);
					}
    break;
case 132:
#line 1538 "gram.y"
{
						plpgsql_error_lineno = plpgsql_yylineno;
						plpgsql_yyval.ival = plpgsql_yylineno;
					}
    break;
}

#line 705 "/usr/local/share/bison/bison.simple"


  plpgsql_yyvsp -= plpgsql_yylen;
  plpgsql_yyssp -= plpgsql_yylen;
#if PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp -= plpgsql_yylen;
#endif

#if PLPGSQL_YYDEBUG
  if (plpgsql_yydebug)
    {
      short *plpgsql_yyssp1 = plpgsql_yyss - 1;
      PLPGSQL_YYFPRINTF (stderr, "state stack now");
      while (plpgsql_yyssp1 != plpgsql_yyssp)
	PLPGSQL_YYFPRINTF (stderr, " %d", *++plpgsql_yyssp1);
      PLPGSQL_YYFPRINTF (stderr, "\n");
    }
#endif

  *++plpgsql_yyvsp = plpgsql_yyval;
#if PLPGSQL_YYLSP_NEEDED
  *++plpgsql_yylsp = plpgsql_yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  plpgsql_yyn = plpgsql_yyr1[plpgsql_yyn];

  plpgsql_yystate = plpgsql_yypgoto[plpgsql_yyn - PLPGSQL_YYNTBASE] + *plpgsql_yyssp;
  if (plpgsql_yystate >= 0 && plpgsql_yystate <= PLPGSQL_YYLAST && plpgsql_yycheck[plpgsql_yystate] == *plpgsql_yyssp)
    plpgsql_yystate = plpgsql_yytable[plpgsql_yystate];
  else
    plpgsql_yystate = plpgsql_yydefgoto[plpgsql_yyn - PLPGSQL_YYNTBASE];

  goto plpgsql_yynewstate;


/*------------------------------------.
| plpgsql_yyerrlab -- here on detecting error |
`------------------------------------*/
plpgsql_yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!plpgsql_yyerrstatus)
    {
      ++plpgsql_yynerrs;

#ifdef PLPGSQL_YYERROR_VERBOSE
      plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];

      if (plpgsql_yyn > PLPGSQL_YYFLAG && plpgsql_yyn < PLPGSQL_YYLAST)
	{
	  PLPGSQL_YYSIZE_T plpgsql_yysize = 0;
	  char *plpgsql_yymsg;
	  int plpgsql_yyx, plpgsql_yycount;

	  plpgsql_yycount = 0;
	  /* Start PLPGSQL_YYX at -PLPGSQL_YYN if negative to avoid negative indexes in
	     PLPGSQL_YYCHECK.  */
	  for (plpgsql_yyx = plpgsql_yyn < 0 ? -plpgsql_yyn : 0;
	       plpgsql_yyx < (int) (sizeof (plpgsql_yytname) / sizeof (char *)); plpgsql_yyx++)
	    if (plpgsql_yycheck[plpgsql_yyx + plpgsql_yyn] == plpgsql_yyx)
	      plpgsql_yysize += plpgsql_yystrlen (plpgsql_yytname[plpgsql_yyx]) + 15, plpgsql_yycount++;
	  plpgsql_yysize += plpgsql_yystrlen ("parse error, unexpected ") + 1;
	  plpgsql_yysize += plpgsql_yystrlen (plpgsql_yytname[PLPGSQL_YYTRANSLATE (plpgsql_yychar)]);
	  plpgsql_yymsg = (char *) PLPGSQL_YYSTACK_ALLOC (plpgsql_yysize);
	  if (plpgsql_yymsg != 0)
	    {
	      char *plpgsql_yyp = plpgsql_yystpcpy (plpgsql_yymsg, "parse error, unexpected ");
	      plpgsql_yyp = plpgsql_yystpcpy (plpgsql_yyp, plpgsql_yytname[PLPGSQL_YYTRANSLATE (plpgsql_yychar)]);

	      if (plpgsql_yycount < 5)
		{
		  plpgsql_yycount = 0;
		  for (plpgsql_yyx = plpgsql_yyn < 0 ? -plpgsql_yyn : 0;
		       plpgsql_yyx < (int) (sizeof (plpgsql_yytname) / sizeof (char *));
		       plpgsql_yyx++)
		    if (plpgsql_yycheck[plpgsql_yyx + plpgsql_yyn] == plpgsql_yyx)
		      {
			const char *plpgsql_yyq = ! plpgsql_yycount ? ", expecting " : " or ";
			plpgsql_yyp = plpgsql_yystpcpy (plpgsql_yyp, plpgsql_yyq);
			plpgsql_yyp = plpgsql_yystpcpy (plpgsql_yyp, plpgsql_yytname[plpgsql_yyx]);
			plpgsql_yycount++;
		      }
		}
	      plpgsql_yyerror (plpgsql_yymsg);
	      PLPGSQL_YYSTACK_FREE (plpgsql_yymsg);
	    }
	  else
	    plpgsql_yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (PLPGSQL_YYERROR_VERBOSE) */
	plpgsql_yyerror ("parse error");
    }
  goto plpgsql_yyerrlab1;


/*--------------------------------------------------.
| plpgsql_yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
plpgsql_yyerrlab1:
  if (plpgsql_yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (plpgsql_yychar == PLPGSQL_YYEOF)
	PLPGSQL_YYABORT;
      PLPGSQL_YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]));
      plpgsql_yychar = PLPGSQL_YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  plpgsql_yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto plpgsql_yyerrhandle;


/*-------------------------------------------------------------------.
| plpgsql_yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
plpgsql_yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  plpgsql_yyn = plpgsql_yydefact[plpgsql_yystate];
  if (plpgsql_yyn)
    goto plpgsql_yydefault;
#endif


/*---------------------------------------------------------------.
| plpgsql_yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
plpgsql_yyerrpop:
  if (plpgsql_yyssp == plpgsql_yyss)
    PLPGSQL_YYABORT;
  plpgsql_yyvsp--;
  plpgsql_yystate = *--plpgsql_yyssp;
#if PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp--;
#endif

#if PLPGSQL_YYDEBUG
  if (plpgsql_yydebug)
    {
      short *plpgsql_yyssp1 = plpgsql_yyss - 1;
      PLPGSQL_YYFPRINTF (stderr, "Error: state stack now");
      while (plpgsql_yyssp1 != plpgsql_yyssp)
	PLPGSQL_YYFPRINTF (stderr, " %d", *++plpgsql_yyssp1);
      PLPGSQL_YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| plpgsql_yyerrhandle.  |
`--------------*/
plpgsql_yyerrhandle:
  plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];
  if (plpgsql_yyn == PLPGSQL_YYFLAG)
    goto plpgsql_yyerrdefault;

  plpgsql_yyn += PLPGSQL_YYTERROR;
  if (plpgsql_yyn < 0 || plpgsql_yyn > PLPGSQL_YYLAST || plpgsql_yycheck[plpgsql_yyn] != PLPGSQL_YYTERROR)
    goto plpgsql_yyerrdefault;

  plpgsql_yyn = plpgsql_yytable[plpgsql_yyn];
  if (plpgsql_yyn < 0)
    {
      if (plpgsql_yyn == PLPGSQL_YYFLAG)
	goto plpgsql_yyerrpop;
      plpgsql_yyn = -plpgsql_yyn;
      goto plpgsql_yyreduce;
    }
  else if (plpgsql_yyn == 0)
    goto plpgsql_yyerrpop;

  if (plpgsql_yyn == PLPGSQL_YYFINAL)
    PLPGSQL_YYACCEPT;

  PLPGSQL_YYDPRINTF ((stderr, "Shifting error token, "));

  *++plpgsql_yyvsp = plpgsql_yylval;
#if PLPGSQL_YYLSP_NEEDED
  *++plpgsql_yylsp = plpgsql_yylloc;
#endif

  plpgsql_yystate = plpgsql_yyn;
  goto plpgsql_yynewstate;


/*-------------------------------------.
| plpgsql_yyacceptlab -- PLPGSQL_YYACCEPT comes here.  |
`-------------------------------------*/
plpgsql_yyacceptlab:
  plpgsql_yyresult = 0;
  goto plpgsql_yyreturn;

/*-----------------------------------.
| plpgsql_yyabortlab -- PLPGSQL_YYABORT comes here.  |
`-----------------------------------*/
plpgsql_yyabortlab:
  plpgsql_yyresult = 1;
  goto plpgsql_yyreturn;

/*---------------------------------------------.
| plpgsql_yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
plpgsql_yyoverflowlab:
  plpgsql_yyerror ("parser stack overflow");
  plpgsql_yyresult = 2;
  /* Fall through.  */

plpgsql_yyreturn:
#ifndef plpgsql_yyoverflow
  if (plpgsql_yyss != plpgsql_yyssa)
    PLPGSQL_YYSTACK_FREE (plpgsql_yyss);
#endif
  return plpgsql_yyresult;
}
#line 1544 "gram.y"



PLpgSQL_expr *
plpgsql_read_expression(int until, const char *expected)
{
	return read_sql_construct(until, expected, true, "SELECT ");
}

static PLpgSQL_expr *
read_sql_stmt(const char *sqlstart)
{
	return read_sql_construct(';', ";", false, sqlstart);
}

static PLpgSQL_expr *
read_sql_construct(int until,
				   const char *expected,
				   bool isexpression,
				   const char *sqlstart)
{
	int					tok;
	int					lno;
	PLpgSQL_dstring		ds;
	int					parenlevel = 0;
	int					nparams = 0;
	int					params[1024];
	char				buf[32];
	PLpgSQL_expr		*expr;

	lno = plpgsql_yylineno;
	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, (char *) sqlstart);

	for (;;)
	{
		tok = plpgsql_yylex();
		if (tok == '(')
			parenlevel++;
		else if (tok == ')')
		{
			parenlevel--;
			if (parenlevel < 0)
				elog(ERROR, "mismatched parentheses");
		}
		else if (parenlevel == 0 && tok == until)
			break;
		/*
		 * End of function definition is an error, and we don't expect to
		 * hit a semicolon either (unless it's the until symbol, in which
		 * case we should have fallen out above).
		 */
		if (tok == 0 || tok == ';')
		{
			plpgsql_error_lineno = lno;
			if (parenlevel != 0)
				elog(ERROR, "mismatched parentheses");
			if (isexpression)
				elog(ERROR, "missing %s at end of SQL expression",
					 expected);
			else
				elog(ERROR, "missing %s at end of SQL statement",
					 expected);
			break;
		}
		if (plpgsql_SpaceScanned)
			plpgsql_dstring_append(&ds, " ");
		switch (tok)
		{
			case T_VARIABLE:
				params[nparams] = plpgsql_yylval.variable->dno;
				snprintf(buf, sizeof(buf), " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			default:
				plpgsql_dstring_append(&ds, plpgsql_yytext);
				break;
		}
	}

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
	expr->dtype			= PLPGSQL_DTYPE_EXPR;
	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->nparams		= nparams;
	while(nparams-- > 0)
		expr->params[nparams] = params[nparams];
	plpgsql_dstring_free(&ds);

	return expr;
}

static PLpgSQL_type *
read_datatype(int tok)
{
	int					lno;
	PLpgSQL_dstring		ds;
	PLpgSQL_type		*result;
	bool				needspace = false;
	int					parenlevel = 0;

	lno = plpgsql_yylineno;

	/* Often there will be a lookahead token, but if not, get one */
	if (tok == PLPGSQL_YYEMPTY)
		tok = plpgsql_yylex();

	if (tok == T_DTYPE)
	{
		/* lexer found word%TYPE and did its thing already */
		return plpgsql_yylval.dtype;
	}

	plpgsql_dstring_init(&ds);

	while (tok != ';')
	{
		if (tok == 0)
		{
			plpgsql_error_lineno = lno;
			if (parenlevel != 0)
				elog(ERROR, "mismatched parentheses");
			elog(ERROR, "incomplete datatype declaration");
		}
		/* Possible followers for datatype in a declaration */
		if (tok == K_NOT || tok == K_ASSIGN || tok == K_DEFAULT)
			break;
		/* Possible followers for datatype in a cursor_arg list */
		if ((tok == ',' || tok == ')') && parenlevel == 0)
			break;
		if (tok == '(')
			parenlevel++;
		else if (tok == ')')
			parenlevel--;
		if (needspace)
			plpgsql_dstring_append(&ds, " ");
		needspace = true;
		plpgsql_dstring_append(&ds, plpgsql_yytext);

		tok = plpgsql_yylex();
	}

	plpgsql_push_back_token(tok);

	plpgsql_error_lineno = lno;	/* in case of error in parse_datatype */

	result = plpgsql_parse_datatype(plpgsql_dstring_get(&ds));

	plpgsql_dstring_free(&ds);

	return result;
}


static PLpgSQL_stmt *
make_select_stmt(void)
{
	PLpgSQL_dstring		ds;
	int					nparams = 0;
	int					params[1024];
	char				buf[32];
	PLpgSQL_expr		*expr;
	PLpgSQL_row			*row = NULL;
	PLpgSQL_rec			*rec = NULL;
	int					tok = 0;
	int					have_nexttok = 0;
	int					have_into = 0;

	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, "SELECT ");

	while(1)
	{
		if (!have_nexttok)
			tok = plpgsql_yylex();
		have_nexttok = 0;
		if (tok == ';')
			break;
		if (tok == 0)
		{
			plpgsql_error_lineno = plpgsql_yylineno;
			elog(ERROR, "unexpected end of file");
		}
		if (tok == K_INTO)
		{
			if (have_into)
			{
				plpgsql_error_lineno = plpgsql_yylineno;
				elog(ERROR, "INTO specified more than once");
			}
			tok = plpgsql_yylex();
			switch (tok)
			{
				case T_ROW:
					row = plpgsql_yylval.row;
					have_into = 1;
					break;

				case T_RECORD:
					rec = plpgsql_yylval.rec;
					have_into = 1;
					break;

				case T_VARIABLE:
				{
					int				nfields = 1;
					char			*fieldnames[1024];
					int				varnos[1024];

					check_assignable(plpgsql_yylval.variable);
					fieldnames[0] = strdup(plpgsql_yytext);
					varnos[0]	  = plpgsql_yylval.variable->dno;

					while ((tok = plpgsql_yylex()) == ',')
					{
						tok = plpgsql_yylex();
						switch(tok)
						{
							case T_VARIABLE:
								check_assignable(plpgsql_yylval.variable);
								fieldnames[nfields] = strdup(plpgsql_yytext);
								varnos[nfields++]	= plpgsql_yylval.variable->dno;
								break;

							default:
								plpgsql_error_lineno = plpgsql_yylineno;
								elog(ERROR, "plpgsql: %s is not a variable",
									 plpgsql_yytext);
						}
					}
					have_nexttok = 1;

					row = malloc(sizeof(PLpgSQL_row));
					row->dtype = PLPGSQL_DTYPE_ROW;
					row->refname = strdup("*internal*");
					row->lineno = plpgsql_yylineno;
					row->rowtypeclass = InvalidOid;
					row->nfields = nfields;
					row->fieldnames = malloc(sizeof(char *) * nfields);
					row->varnos = malloc(sizeof(int) * nfields);
					while (--nfields >= 0)
					{
						row->fieldnames[nfields] = fieldnames[nfields];
						row->varnos[nfields] = varnos[nfields];
					}

					plpgsql_adddatum((PLpgSQL_datum *)row);

					have_into = 1;
				}
				break;

				default:
					/* Treat the INTO as non-special */
					plpgsql_dstring_append(&ds, " INTO ");
					have_nexttok = 1;
					break;
			}
			continue;
		}

		if (plpgsql_SpaceScanned)
			plpgsql_dstring_append(&ds, " ");
		switch (tok)
		{
			case T_VARIABLE:
				params[nparams] = plpgsql_yylval.variable->dno;
				snprintf(buf, sizeof(buf), " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			default:
				plpgsql_dstring_append(&ds, plpgsql_yytext);
				break;
		}
	}

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
	expr->dtype			= PLPGSQL_DTYPE_EXPR;
	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->nparams		= nparams;
	while(nparams-- > 0)
		expr->params[nparams] = params[nparams];
	plpgsql_dstring_free(&ds);

	if (have_into)
	{
		PLpgSQL_stmt_select *select;

		select = malloc(sizeof(PLpgSQL_stmt_select));
		memset(select, 0, sizeof(PLpgSQL_stmt_select));
		select->cmd_type = PLPGSQL_STMT_SELECT;
		select->rec		 = rec;
		select->row		 = row;
		select->query	 = expr;

		return (PLpgSQL_stmt *)select;
	}
	else
	{
		PLpgSQL_stmt_execsql *execsql;

		execsql = malloc(sizeof(PLpgSQL_stmt_execsql));
		execsql->cmd_type = PLPGSQL_STMT_EXECSQL;
		execsql->sqlstmt  = expr;

		return (PLpgSQL_stmt *)execsql;
	}
}


static PLpgSQL_stmt *
make_fetch_stmt(void)
{
	int					tok;
	PLpgSQL_row		   *row = NULL;
	PLpgSQL_rec		   *rec = NULL;
	PLpgSQL_stmt_fetch *fetch;
	int					have_nexttok = 0;

	/* We have already parsed everything through the INTO keyword */

	tok = plpgsql_yylex();
	switch (tok)
	{
		case T_ROW:
			row = plpgsql_yylval.row;
			break;

		case T_RECORD:
			rec = plpgsql_yylval.rec;
			break;

		case T_VARIABLE:
			{
				int				nfields = 1;
				char			*fieldnames[1024];
				int				varnos[1024];

				check_assignable(plpgsql_yylval.variable);
				fieldnames[0] = strdup(plpgsql_yytext);
				varnos[0]	  = plpgsql_yylval.variable->dno;

				while ((tok = plpgsql_yylex()) == ',')
				{
					tok = plpgsql_yylex();
					switch(tok)
					{
						case T_VARIABLE:
							check_assignable(plpgsql_yylval.variable);
							fieldnames[nfields] = strdup(plpgsql_yytext);
							varnos[nfields++]	= plpgsql_yylval.variable->dno;
							break;

						default:
							plpgsql_error_lineno = plpgsql_yylineno;
							elog(ERROR, "plpgsql: %s is not a variable",
								 plpgsql_yytext);
					}
				}
				have_nexttok = 1;

				row = malloc(sizeof(PLpgSQL_row));
				row->dtype = PLPGSQL_DTYPE_ROW;
				row->refname = strdup("*internal*");
				row->lineno = plpgsql_yylineno;
				row->rowtypeclass = InvalidOid;
				row->nfields = nfields;
				row->fieldnames = malloc(sizeof(char *) * nfields);
				row->varnos = malloc(sizeof(int) * nfields);
				while (--nfields >= 0)
				{
					row->fieldnames[nfields] = fieldnames[nfields];
					row->varnos[nfields] = varnos[nfields];
				}

				plpgsql_adddatum((PLpgSQL_datum *)row);
			}
			break;

		default:
			plpgsql_yyerror("syntax error");
	}

	if (!have_nexttok)
		tok = plpgsql_yylex();

	if (tok != ';')
		plpgsql_yyerror("syntax error");

	fetch = malloc(sizeof(PLpgSQL_stmt_select));
	memset(fetch, 0, sizeof(PLpgSQL_stmt_fetch));
	fetch->cmd_type = PLPGSQL_STMT_FETCH;
	fetch->rec		 = rec;
	fetch->row		 = row;

	return (PLpgSQL_stmt *)fetch;
}


static PLpgSQL_expr *
make_tupret_expr(PLpgSQL_row *row)
{
	PLpgSQL_dstring		ds;
	PLpgSQL_expr		*expr;
	int					i;
	char				buf[16];

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * (row->nfields - 1));
	expr->dtype			= PLPGSQL_DTYPE_EXPR;

	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, "SELECT ");

	for (i = 0; i < row->nfields; i++)
	{
		sprintf(buf, "%s$%d", (i > 0) ? "," : "", i + 1);
		plpgsql_dstring_append(&ds, buf);
		expr->params[i] = row->varnos[i];
	}

	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->plan_argtypes = NULL;
	expr->nparams		= row->nfields;

	plpgsql_dstring_free(&ds);
	return expr;
}

static void
check_assignable(PLpgSQL_datum *datum)
{
	switch (datum->dtype)
	{
		case PLPGSQL_DTYPE_VAR:
			if (((PLpgSQL_var *) datum)->isconst)
			{
				plpgsql_error_lineno = plpgsql_yylineno;
				elog(ERROR, "%s is declared CONSTANT",
					 ((PLpgSQL_var *) datum)->refname);
			}
			break;
		case PLPGSQL_DTYPE_RECFIELD:
			/* always assignable? */
			break;
		case PLPGSQL_DTYPE_TRIGARG:
			plpgsql_yyerror("cannot assign to tg_argv");
			break;
		default:
			plpgsql_yyerror("check_assignable: unexpected datum type");
			break;
	}
}
